import java.awt.Dimension;

import javax.swing.JFrame;
import javax.swing.JTabbedPane;

import main.experimental.Experimental;
import main.guildmodel.GuildDatabasePanel;
import main.interferencemodel.InterferenceDatabasePanel;
import main.phrasemodel.controller.PhraseMainController;
import main.phrasemodel.model.PhraseModel;
import main.setting.SettingPanel;
import tools.db.DBCheck;
import tools.i18n.I18N;
import tools.util.Constant;
import tools.util.ScreenSet;

public class MainFrame extends JFrame {
	
	private static final long serialVersionUID = 3206847208968227199L;
	
	public MainFrame(){
		try {
			// TODO remove this after SPRING is introduced
			Class.forName("model.Question");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		
		JTabbedPane tabbedPane = new JTabbedPane();
		
		PhraseModel pModel = new PhraseModel();
		new PhraseMainController(pModel, tabbedPane);
		
		InterferenceDatabasePanel ifPanel = new InterferenceDatabasePanel();
		tabbedPane.addTab(Constant.FAKEQUESTION_MODEL, ifPanel);
		
		GuildDatabasePanel gdPanel = new GuildDatabasePanel();
		tabbedPane.addTab(Constant.GUIDES_MODEL, gdPanel);
		
		Experimental qp = new Experimental();
		tabbedPane.addTab(Constant.EXPERIMENT_MODEL, qp);
		
		SettingPanel setPanel = new SettingPanel();
		tabbedPane.addTab(Constant.SETTING, setPanel);
		
		this.add(tabbedPane);
		this.setTitle(Constant.MAINFRAME);
		this.setMinimumSize(new Dimension(850, 400));
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setVisible( true );
		this.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
	}
	
	public static void main( String args[] ){
		DBCheck.checkFileExist();
		I18N.setLanguage();
		
		MainFrame mf = new MainFrame();
		mf.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
	}
}
