package main.experimental.ui.executeQuestionnaire;

import java.sql.Date;
import java.util.ArrayList;
import java.util.Calendar;

import main.experimental.ui.innerQuestionPane.InnerQuestionPane;
import model.Question;
import model.Questionnaire;
import model.QuestionnairesTableModel;

public class ExecuteQuestion {
	//TODO set flow control and store data and call the Dialog to let user input the info
	private String subject = null;
	private boolean questionStart = false;
	private ExecuteQuestion exeQue;
	private ArrayList<Question> questions;
	private int questionsSize,nowDoing,row;
	private Questionnaire questionnaire;
	private QuestionnairesTableModel qtModel;
	private InnerQuestionPane iq;
	
	public ExecuteQuestion(InnerQuestionPane iq, QuestionnairesTableModel qtModel, int row) {
		this.iq = iq;
		exeQue = this;
		questionnaire = qtModel.getExperiment().getQuestionnaires().get(row);
		this.qtModel = qtModel;
		this.row = row;
		CheckState();
	}
	
	public void CheckState(){
		if(null == subject){
			new ExecuteQuestionDialog1(iq, exeQue);
		}else if(!questionStart){
			new ExecuteQuestionDialog2(iq, exeQue, getGuideSentence());
		}else if(hasNextQuestion()){
			new ExecuteQuestionDialog3(iq, exeQue, questions.get(nowDoing-1).getQuestion(), getYes(), getNo());
		}else{
			new ExecuteQuestionDialog4(iq, exeQue);
		}
	}

	private void makeQuestion() {
		questions = new ArrayList<Question>();
		questions = questionnaire.getQuestions();
		nowDoing = 0;
		questionsSize = questions.size();
	}
	
	public void setSubject(String subject) {
		this.subject = subject;
	}
	
	public void setQuestionStart(){
		questionStart = true;
		makeQuestion();
	}	
	
	private boolean hasNextQuestion() {
		if(nowDoing < questionsSize){
			nowDoing++;
			return true;
		}else{
			return false;
		}
	}

	public String getGuideSentence(){
		return questionnaire.getExperiment().getGuideGuide();
	}
	
	public String getYes(){
		return questionnaire.getExperiment().getPositive();
	}
	
	public String getNo(){
		return questionnaire.getExperiment().getNegative();
	}

	public void setAnswer(boolean answer) {
		questions.get(nowDoing-1).setAnswer(answer);
	}

	public void saveToDB() {
		questionnaire.setSubject(subject);
		questionnaire.setState(Questionnaire.State.COMPLETED);
		Date answerDate = new Date(Calendar.getInstance().getTimeInMillis());
		questionnaire.setAnswerDate(answerDate);
		
		qtModel.fireTableRowsUpdated(row, row);
	}
}
