package main.experimental.ui.executeQuestionnaire;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

import main.experimental.ui.innerQuestionPane.InnerQuestionPane;
import tools.util.Constant;
import tools.util.ScreenSet;


@SuppressWarnings("serial")
public class ExecuteQuestionDialog1 extends JDialog{
	
	private JPanel execQuePanel,btnPanel;
	private JLabel lbSubject;
	private JTextField tfSubject;
	private JButton continueBtn;
	private String subject;
	private ExecuteQuestion exeQue;
	private ExecuteQuestionDialog1 eq1;
	
	public ExecuteQuestionDialog1(InnerQuestionPane iq, ExecuteQuestion exeQue) {
		super((Frame) iq.getTopLevelAncestor(), true);
		this.exeQue = exeQue;
		execQuePanel = new JPanel();
		btnPanel = new JPanel();
		eq1 = this;
		
		lbSubject = new JLabel(Constant.EXP_EXECUTE_SURVEY_SUBJECT_NAME);
		tfSubject = new JTextField(15);
		execQuePanel.setLayout(new FlowLayout());
		execQuePanel.setBorder(BorderFactory.createTitledBorder(Constant.EXP_EXECUTE_SURVEY_SUBJECT_INFO));
		execQuePanel.add(lbSubject);
		execQuePanel.add(tfSubject);
		
		btnPanel.setLayout(new FlowLayout());
		btnPanel.add(continueBtn = new JButton(Constant.CONTINUE));
		
		buttonEventHandle();
		
		this.setLayout(new BorderLayout());
		this.add(execQuePanel,BorderLayout.CENTER);
		this.add(btnPanel,BorderLayout.SOUTH);
		
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setTitle(Constant.EXP_SURVEY_EXECUTE);
		this.setVisible(true);
	}

	private void buttonEventHandle() {
		Action doClickOk = new AbstractAction() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				continueBtn.doClick();
			}
		};
		tfSubject.getInputMap().put(KeyStroke.getKeyStroke("ENTER"), "enter2submit");
		tfSubject.getActionMap().put("enter2submit", doClickOk);
			
		continueBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				subject = tfSubject.getText();
				if("".equals(subject)){
					JOptionPane.showMessageDialog(eq1, Constant.EXP_EXECUTE_SURVEY_MSG_NOT_FILL, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
				}else{
					exeQue.setSubject(subject);
					dispose();
					exeQue.CheckState();
				}
			}
		});
	}

}
