package main.experimental.ui.executeQuestionnaire;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTextArea;

import main.experimental.ui.innerQuestionPane.InnerQuestionPane;
import tools.util.Constant;
import tools.util.ScreenSet;


@SuppressWarnings("serial")
public class ExecuteQuestionDialog2 extends JDialog {
	
	private JPanel execQuePanel,btnPanel;
	private JTextArea taGuildSentence;
	private JButton continueBtn;
	private ExecuteQuestion exeQue;
	
	public ExecuteQuestionDialog2(InnerQuestionPane iq, ExecuteQuestion exeQue, String guildSentence) {
		super((Frame) iq.getTopLevelAncestor(), true);
		this.exeQue = exeQue;
		execQuePanel = new JPanel();
		btnPanel = new JPanel();
		
		taGuildSentence = new JTextArea();
		taGuildSentence.setText(guildSentence);
		taGuildSentence.setEditable(false);
		taGuildSentence.setFont(new Font(taGuildSentence.getFont().getFontName(), taGuildSentence.getFont().getStyle(), 24));
		execQuePanel.setLayout(new FlowLayout());
		execQuePanel.setBorder(BorderFactory.createTitledBorder(Constant.EXP_GUIDE));
		execQuePanel.add(taGuildSentence);
		
		btnPanel.setLayout(new FlowLayout());
		btnPanel.add(continueBtn = new JButton(Constant.CONTINUE));
		
		buttonEventHandle();
		
		this.setLayout(new BorderLayout());
		this.add(execQuePanel,BorderLayout.CENTER);
		this.add(btnPanel,BorderLayout.SOUTH);
		
		this.pack();
		ScreenSet.setMaximizedWindow(this);
		this.setAlwaysOnTop(true);
		this.setTitle(Constant.EXP_SURVEY_EXECUTE);
		this.setVisible(true);
	}
	
	private void buttonEventHandle() {
		continueBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				exeQue.setQuestionStart();
				dispose();
				exeQue.CheckState();
			}
		});
	}
}
