package main.experimental.ui.executeQuestionnaire;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import main.experimental.ui.innerQuestionPane.InnerQuestionPane;
import tools.util.Constant;
import tools.util.ScreenSet;


@SuppressWarnings("serial")
public class ExecuteQuestionDialog3 extends JDialog {
	
	private JPanel execQuePanel,radioPanel,actionPanel;
	private JLabel lbSentence;
	private JRadioButton rbYes, rbNo;
	private JButton okBtn;
	private ExecuteQuestion exeQue;
	private ExecuteQuestionDialog3 eq3;
		
	public ExecuteQuestionDialog3(InnerQuestionPane iq, ExecuteQuestion exeQue, String sentence, String pos, String neg) {
		super((Frame) iq.getTopLevelAncestor(), true);
		this.exeQue = exeQue;
		execQuePanel = new JPanel();
		radioPanel = new JPanel();
		actionPanel = new JPanel();
		eq3 = this;
		
		lbSentence = new JLabel(sentence);
		lbSentence.setFont(new Font(lbSentence.getFont().getFontName(), lbSentence.getFont().getStyle(), 24));
		
		execQuePanel.setLayout(new FlowLayout());
		execQuePanel.setBorder(BorderFactory.createTitledBorder(Constant.EXP_QUE));
		execQuePanel.add(lbSentence);
		
		radioPanel.add(rbYes = new JRadioButton(pos));
		radioPanel.add(rbNo = new JRadioButton(neg));
		rbYes.setFont(new Font(rbYes.getFont().getFontName(), rbYes.getFont().getStyle(), 24));
		rbNo.setFont(new Font(rbNo.getFont().getFontName(), rbNo.getFont().getStyle(), 24));
		ButtonGroup btnGroup = new ButtonGroup();
		btnGroup.add(rbYes);
		btnGroup.add(rbNo);
		
		actionPanel.setLayout(new BoxLayout(actionPanel,BoxLayout.Y_AXIS));
		actionPanel.add(radioPanel);
		actionPanel.add(okBtn = new JButton(Constant.OK));

		buttonEventHandle();
		
		this.setLayout(new BorderLayout());
		this.add(execQuePanel,BorderLayout.CENTER);
		this.add(actionPanel,BorderLayout.SOUTH);
		
		this.pack();
		ScreenSet.setMaximizedWindow(this);
		this.setAlwaysOnTop(true);
		this.setTitle(Constant.EXP_SURVEY_EXECUTE);
		this.setVisible(true);
	}

	private void buttonEventHandle() {
		okBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				if(!rbYes.isSelected() && !rbNo.isSelected()){
					JOptionPane.showMessageDialog(eq3, Constant.EXP_EXECUTE_SURVEY_MSG_NOT_SELECT, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
				}else{
					boolean answer = rbYes.isSelected() ? true:false ;
					exeQue.setAnswer(answer);
					dispose();
					exeQue.CheckState();
				}
			}
		});
	}

}
