package main.experimental.ui.executeQuestionnaire;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import tools.util.Constant;
import tools.util.ScreenSet;

import main.experimental.ui.innerQuestionPane.InnerQuestionPane;


@SuppressWarnings("serial")
public class ExecuteQuestionDialog4 extends JDialog {
	
	private JPanel msgPanel, btnPanel;
	private JLabel lbMsg;
	private JButton okBtn;
	private ExecuteQuestion exeQue;
	
	public ExecuteQuestionDialog4(InnerQuestionPane iq, ExecuteQuestion exeQue) {
		super((Frame) iq.getTopLevelAncestor(), true);
		this.exeQue = exeQue;
		msgPanel = new JPanel();
		btnPanel = new JPanel();
		
		lbMsg = new JLabel(Constant.EXP_EXECUTE_SURVEY_MSG_END);
		lbMsg.setFont(new Font(lbMsg.getFont().getFontName(), lbMsg.getFont().getStyle(), 24));
		msgPanel.add(lbMsg);
		
		okBtn = new JButton(Constant.EXP_EXECUTE_SURVEY_SAVE_SURVEY);
		btnPanel.add(okBtn);

		buttonEventHandle();
		
		this.setLayout(new BorderLayout());
		this.add(msgPanel,BorderLayout.CENTER);
		this.add(btnPanel,BorderLayout.SOUTH);
		
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		this.setTitle(Constant.EXP_SURVEY_EXECUTE);
		this.setVisible(true);
	}

	private void buttonEventHandle() {
		okBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				exeQue.saveToDB();
				dispose();
			}
		});
	}
}
