package main.experimental.ui.experdialog;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

import tools.util.Constant;
import tools.util.ScreenSet;

import model.Experiment;
import model.ExperimentsTableModel;

@SuppressWarnings("serial")
public class EditExperDialog extends JDialog {
	
	private JTextField tfTitle = new JTextField(15);
	private JButton editBtn = new JButton(Constant.OK);
	private JButton cancelBtn = new JButton(Constant.CANCEL);
	private ExperimentsTableModel expModel;
	private int seletedRow;
		
	public EditExperDialog(ExperiencePane ep, ExperimentsTableModel expModel, int selectedRow) {
		super((Frame) ep.getTopLevelAncestor(), true);
		this.expModel = expModel;
		this.seletedRow = selectedRow;
		
		if (null != expModel.getValueAt(selectedRow, 1)) {
			tfTitle.setText(expModel.getValueAt(seletedRow, 1).toString());
		}
		buttonEventHandle();
		
		JPanel editExpPanel = new JPanel();
		editExpPanel.setLayout(new FlowLayout());
		editExpPanel.add(new JLabel(Constant.EXP_EXP_TITLE+"："));
		editExpPanel.add(tfTitle);
		
		JPanel btnPanel = new JPanel();
		btnPanel.setLayout(new FlowLayout());
		btnPanel.add(editBtn);
		btnPanel.add(cancelBtn);
		
		this.setLayout(new BorderLayout());
		this.add(editExpPanel, BorderLayout.CENTER);
		this.add(btnPanel, BorderLayout.SOUTH);
		this.setTitle(Constant.EXP_EXP_EDIT);
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setVisible(true);
	}

	private void buttonEventHandle() {
		Action doClickOk = new AbstractAction() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				editBtn.doClick();
			}
		};
		tfTitle.getInputMap().put(KeyStroke.getKeyStroke("ENTER"), "enter2submit");
		tfTitle.getActionMap().put("enter2submit", doClickOk);
		
		editBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent ae) {
				Experiment e = expModel.getAllExperiments().get(seletedRow);
				e.setTitle(tfTitle.getText());
				expModel.fireTableRowsUpdated(seletedRow, seletedRow);
				dispose();
			}
		});
		
		cancelBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				dispose();
			}
		});
	}
	
}
