package main.experimental.ui.experdialog;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextField;

import main.phrasemodel.management.model.ExperModel;
import main.phrasemodel.model.PhraseModel;
import main.phrasemodel.vo.PhraseData;
import model.CachePhraseModel;
import model.Experiment;
import model.ExperimentsTableModel;
import model.FakeQuestionsModel;
import model.GuidesModel;
import model.Questionnaire;
import tools.util.ComboBoxRenderer;
import tools.util.Constant;
import tools.util.ScreenSet;
import vo.CachePhraseData;

@SuppressWarnings("serial")
public class NewExperDialog extends JDialog implements ActionListener, ItemListener {
	
	private JButton newBtn = new JButton(Constant.OK);
	private JButton cancelBtn = new JButton(Constant.CANCEL);

	private JTextField tfTitle = new JTextField();
	private JTextField tfPositive = new JTextField();
	private JTextField tfNegative = new JTextField();
	private JTextField tfQuestionnum = new JTextField();
	private JComboBox cbPhrase;// = new JComboBox();
	private JComboBox cbIfnum = new JComboBox();
	private JComboBox cbGuidesentence = new JComboBox();
	private JLabel lbExpernum = new JLabel("　　　　　　　　　");
	private String select = Constant.WARNING_MSG_PLEASE_SELECT+"：";

	private ExperModel mtModel;
	private JTable expTable;
	private NewExperDialog ne;
	
	public NewExperDialog(ExperiencePane ep, ExperModel mtModel, JTable tbl) {
		super((Frame) ep.getTopLevelAncestor(),true);
		this.mtModel = mtModel;
		this.expTable = tbl;
		ne = this;
		
		//取得句庫裡所有的物件
		ArrayList<PhraseData> pList = PhraseModel.getAllPhrase();
		//轉成 Array
		PhraseData[] pd = pList.toArray(new PhraseData[pList.size()]);
		
		cbPhrase = new JComboBox(pd);
		//自訂 ComboBox 要怎麼顯示，這裡是顯示 Phrase Description。
		ComboBoxRenderer renderer = new ComboBoxRenderer();
		cbPhrase.setRenderer(renderer);
		cbPhrase.setSelectedIndex(0);
		showExperNum();
		
		cancelBtn.addActionListener(this);
		newBtn.addActionListener(this);
		cbPhrase.addItemListener(this);

		//TODO 畫面另外再調
		JPanel newExpPanel = new JPanel();
		newExpPanel.setLayout(new GridLayout(0, 2));		
		newExpPanel.add(new JLabel(Constant.EXP_EXP_TITLE));
		newExpPanel.add(tfTitle);
		newExpPanel.add(new JLabel(Constant.EXP_EXP_POSITIVE));
		newExpPanel.add(tfPositive);
		newExpPanel.add(new JLabel(Constant.EXP_EXP_NEGATIVE));
		newExpPanel.add(tfNegative);
		newExpPanel.add(new JLabel(Constant.EXP_EXP_FACTOR));
		newExpPanel.add(cbPhrase); 
		newExpPanel.add(new JLabel(" "));
		newExpPanel.add(lbExpernum);
		newExpPanel.add(new JLabel(Constant.EXP_EXP_FAKE_QUE_NUM));
		newExpPanel.add(cbIfnum = new JComboBox());
		newExpPanel.add(new JLabel(Constant.EXP_EXP_QUE_NUM));
		newExpPanel.add(tfQuestionnum = new JTextField());
		newExpPanel.add(new JLabel(Constant.EXP_GUIDE));
		newExpPanel.add(cbGuidesentence = new JComboBox());
		
		for (int i = FakeQuestionsModel.getFakeQuestionNum(); i >= 0; i--){
			cbIfnum.addItem(""+i);
		}
		// TODO add a read-only text-area for guideGuide
		GuidesModel guides = GuidesModel.getTableModel();
		cbGuidesentence.addItem(select);
		for (int i = 0; i < guides.getRowCount(); ++i) {
			cbGuidesentence.addItem(GuidesModel.getTitle(guides.getId(i)));
		}
				
		JPanel btnPanel = new JPanel();
		btnPanel.setLayout(new FlowLayout());
		btnPanel.add(newBtn);
		btnPanel.add(cancelBtn);
		
		this.setLayout(new BorderLayout());
		this.add(newExpPanel,BorderLayout.CENTER);
		this.add(btnPanel,BorderLayout.SOUTH);
		
		this.setTitle(Constant.EXP_EXP_INSERT);
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setVisible(true);
	}
	
	// shall we move this to Experiment data model?
	private boolean validateNewForm() {
		boolean isErr = false;
		if("".equals(tfTitle.getText())){
			JOptionPane.showMessageDialog(ne, Constant.EXP_EXP_TITLE+" "+Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
			isErr = true;
		}else if("".equals(tfPositive.getText())){
			JOptionPane.showMessageDialog(ne, Constant.EXP_EXP_POSITIVE+" "+Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
			isErr = true;
		}else if("".equals(tfNegative.getText())){
			JOptionPane.showMessageDialog(ne, Constant.EXP_EXP_NEGATIVE+" "+Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
			isErr = true;
		}else if(select.equals(cbPhrase.getSelectedItem())){
			JOptionPane.showMessageDialog(ne, Constant.EXP_EXP_FACTOR+" "+Constant.WARNING_MSG_PLEASE_SELECT, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
			isErr = true;
		} else if(select.equals(cbGuidesentence.getSelectedItem())){
			JOptionPane.showMessageDialog(ne, Constant.EXP_GUIDE+" "+Constant.WARNING_MSG_PLEASE_SELECT, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
			isErr = true;
		} else{
			try{
				Integer.parseInt(tfQuestionnum.getText());
			}catch (NumberFormatException e) {
				JOptionPane.showMessageDialog(ne, Constant.EXP_EXP_QUE_NUM+" "+Constant.ERROR_MSG_MUST_BE_A_NUM, Constant.ERROR_MSG_ERROR, JOptionPane.ERROR_MESSAGE);
				isErr = true;
			}
		}
		return isErr;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource().equals(cancelBtn)){
			dispose();
		}else if(e.getSource().equals(newBtn)){
			if(!validateNewForm()){
				int id = GuidesModel.getTableModel().getId(cbGuidesentence.getSelectedIndex()-1);
				// transform factor description back to id
				PhraseData pd = (PhraseData)cbPhrase.getSelectedItem();
				int factorId = pd.getId();
				
				Experiment exp = new Experiment(tfTitle.getText(), tfPositive.getText(), tfNegative.getText(), 
						factorId, Integer.parseInt(cbIfnum.getSelectedItem().toString()), 
						GuidesModel.getTitle(id), GuidesModel.getGuide(id), Integer.parseInt(tfQuestionnum.getText()));
				ExperimentsTableModel exps = ExperimentsTableModel.getInstance();

				exps.getAllExperiments().add(0, exp);
				exps.fireTableRowsInserted(0, 0);

				expTable.getSelectionModel().clearSelection();
				expTable.getSelectionModel().setSelectionInterval(0, 0);
				
				CachePhraseModel cacheModel = new CachePhraseModel();
				String factorDes = pd.getDescription();
				ArrayList<String> realQuestions = ExperModel.getExperSentenceByPhraseId(factorId);
				
				//將phrase存進cache_phrase
				int i = 1;
				for(String question : realQuestions){
					CachePhraseData cpData = new CachePhraseData();
					cpData.setExperimentalSentence(question);
					cpData.setPhraseDescription(factorDes);
					cpData.setPhraseId(factorId);
					cpData.setQuestionexperId(exp.getId());
					int factorNum = ExperModel.getCaseNum(factorId)/2;
					cpData.setPhraseCount(ExperModel.getCaseNum(factorId)/2*10+i);
					cacheModel.insert(cpData);
					if(factorNum==i/2){
						i=1;
					}else{
						i++;
					}
				}
				// loop questionnaireNum to create questionnaire
				int questionnaireNum = Integer.parseInt(tfQuestionnum.getText());
				for (; questionnaireNum > 0; --questionnaireNum) {
					new Questionnaire(exp);
				}
				
				dispose();
			}
		}
	}
	
	@Override
	public void itemStateChanged(ItemEvent item) {
		if(item.getSource().equals(cbPhrase)){
			showExperNum();
		}
	}
	
	protected void showExperNum(){
		PhraseData pd = (PhraseData)cbPhrase.getSelectedItem();
		int num = mtModel.getNumOfExperByPhraseId(pd.getId());
		lbExpernum.setText(Constant.EXP_EXP_MSG_TOTAL+" "+ num +" "+Constant.EXP_EXP_MSG_NUM_EXP);
	}
}
