package main.experimental.ui.innerQuestionPane;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

import tools.util.Constant;
import tools.util.ScreenSet;

import model.Questionnaire;
import model.QuestionnairesTableModel;


@SuppressWarnings("serial")
public class EditQueDialog extends JDialog {
	
	private JTextField tfNotes = new JTextField(15);
	private JButton editBtn = new JButton(Constant.OK);
	private JButton cancelBtn = new JButton(Constant.CANCEL);
	private QuestionnairesTableModel qtModel;
	private int row;
	
	public EditQueDialog(InnerQuestionPane iq, QuestionnairesTableModel qtModel, int row) {
		super((Frame) iq.getTopLevelAncestor(),true);
		this.qtModel = qtModel;
		this.row = row;
		
		Questionnaire questionnaire = qtModel.getExperiment().getQuestionnaires().get(row);
		tfNotes.setText(questionnaire.getNotes());
		buttonEventHandle();

		JPanel editQuePanel = new JPanel();
		editQuePanel.setLayout(new FlowLayout());
		editQuePanel.add(new JLabel(Constant.EXP_SURVEY_NOTES+"："));
		editQuePanel.add(tfNotes);
		
		JPanel btnPanel = new JPanel();
		btnPanel.setLayout(new FlowLayout());
		btnPanel.add(editBtn);
		btnPanel.add(cancelBtn);
				
		this.setLayout(new BorderLayout());
		this.add(editQuePanel,BorderLayout.CENTER);
		this.add(btnPanel,BorderLayout.SOUTH);
		
		this.setTitle(Constant.EXP_SURVEY_EDIT);
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setVisible(true);
	}

	private void buttonEventHandle() {
		Action doClickOk = new AbstractAction() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				editBtn.doClick();
			}
		};
		tfNotes.getInputMap().put(KeyStroke.getKeyStroke("ENTER"), "enter2submit");
		tfNotes.getActionMap().put("enter2submit", doClickOk);
		
		editBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				Questionnaire questionnaire = qtModel.getExperiment().getQuestionnaires().get(row);
				questionnaire.setNotes(tfNotes.getText());
				qtModel.fireTableRowsUpdated(row, row);
				dispose();
			}
		});
		cancelBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		});
	}
	
}
