package main.experimental.ui.innerQuestionPane.Refill;

import java.sql.Date;
import java.util.ArrayList;
import java.util.Calendar;

import javax.swing.ButtonGroup;

import main.experimental.ui.innerQuestionPane.InnerQuestionPane;
import model.Questionnaire;
import model.QuestionnairesTableModel;

public class Refill {
	
	public static enum State {SUBJECT, REFILL};
	private State currentState; 
	
	private InnerQuestionPane iq;
	private QuestionnairesTableModel qtModel;
	private Questionnaire q;
	private int row;
	
	private String subject;
	
	public Refill(InnerQuestionPane iq, QuestionnairesTableModel qtModel, int row) {
		this.iq = iq;
		this.qtModel = qtModel;
		this.row = row;
		this.q = qtModel.getExperiment().getQuestionnaires().get(row);
		currentState = State.SUBJECT;
		checkstate();
	}

	void checkstate() {
		if(currentState == State.SUBJECT){
			new RefillSubject(iq, this);
		} else if(currentState == State.REFILL) {
			new RefillSurvey(iq, q, this, getPositive(), getNegative());
		}
	}

//============ Tool ============
	public void setSubject(String subject) {
		this.subject = subject;
	}
	
	private String getPositive(){
		return q.getExperiment().getPositive();
	}
	
	private String getNegative(){
		return q.getExperiment().getNegative();
	}

//============ save to DB ============
	public void saveToDB(ArrayList<ButtonGroup> questions){
		q.setSubject(subject);
		q.setState(Questionnaire.State.COMPLETED);
		Date answerDate = new Date(Calendar.getInstance().getTimeInMillis());
		q.setAnswerDate(answerDate);
		
		for(int i=0 ; i<questions.size() ; i++){
			boolean answer = "true".equals(questions.get(i).getSelection().getActionCommand()) ? true : false;
			q.getQuestions().get(i).setAnswer(answer);
		}
		
		qtModel.fireTableRowsUpdated(row, row);
	}

//============ 以下是Getter & Setter ============
	public void setCurrentState(State state) {
		this.currentState = state;
	}
}
