package main.experimental.ui.innerQuestionPane.Refill;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

import main.experimental.ui.innerQuestionPane.InnerQuestionPane;
import tools.util.Constant;
import tools.util.ScreenSet;

@SuppressWarnings("serial")
public class RefillSubject extends JDialog {
	
	private Refill refill;
	private RefillSubject dialog;
	
	private JPanel refillPanel, btnPanel;
	private JLabel lbSubject;
	private JTextField tfSubject;
	private JButton continueBtn;
	
	public RefillSubject(InnerQuestionPane iq, Refill refill) {
		super((Frame) iq.getTopLevelAncestor(), true);
		this.refill = refill;
		dialog = this;
		refillPanel = new JPanel();
		btnPanel = new JPanel();
		
		lbSubject = new JLabel(Constant.EXP_EXECUTE_SURVEY_SUBJECT_NAME);
		tfSubject = new JTextField(15);
		refillPanel.setLayout(new FlowLayout());
		refillPanel.setBorder(BorderFactory.createTitledBorder(Constant.EXP_EXECUTE_SURVEY_SUBJECT_INFO));
		refillPanel.add(lbSubject);
		refillPanel.add(tfSubject);
		
		btnPanel.setLayout(new FlowLayout());
		btnPanel.add(continueBtn = new JButton(Constant.CONTINUE));
		
		buttonEvenHandle();
		
		this.setLayout(new BorderLayout());
		this.add(refillPanel, BorderLayout.CENTER);
		this.add(btnPanel, BorderLayout.SOUTH);
		
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setTitle(Constant.REFILL+" 1/2");
		this.setVisible(true);
	}
	
	private void buttonEvenHandle(){
		Action doClickOk = new AbstractAction() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				continueBtn.doClick();
			}
		};
		tfSubject.getInputMap().put(KeyStroke.getKeyStroke("ENTER"), "enter2submit");
		tfSubject.getActionMap().put("enter2submit", doClickOk);
		
		continueBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				String subject = tfSubject.getText();
				if("".equals(subject)){
					JOptionPane.showMessageDialog(dialog, Constant.EXP_EXECUTE_SURVEY_MSG_NOT_FILL, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
				}else{
					refill.setSubject(subject);
					dispose();
					refill.setCurrentState(Refill.State.REFILL);
					refill.checkstate();
				}
			}
		});
	}
}
