package main.experimental.ui.innerQuestionPane.Refill;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;

import main.experimental.ui.innerQuestionPane.InnerQuestionPane;
import model.Question;
import model.Questionnaire;
import tools.util.Constant;
import tools.util.ScreenSet;

@SuppressWarnings("serial")
public class RefillSurvey extends JDialog {

	private Refill refill;
	private Questionnaire q;
	private String pos;
	private String neg;

	private JScrollPane js;
	private JPanel singleQuestionPanel;
	private JRadioButton rbYes;
	private JRadioButton rbNo;
	private JLabel lbQuestion;
	private ArrayList<ButtonGroup> questions;
	private JPanel questionPanel;
	private JPanel btnPanel;
	private JButton resetBtn;
	private JButton okBtn;
	private RefillSurvey rs;
	
	public RefillSurvey(InnerQuestionPane iq, Questionnaire q, Refill refill, String pos, String neg) {
		super((Frame) iq.getTopLevelAncestor(), true);
		this.q = q;
		this.refill = refill;
		this.pos = pos;
		this.neg = neg;
		this.rs = this;
		
		createViews();
		buttonEvenHandle();
		
		this.pack();
		this.setMinimumSize(new Dimension(450, 400));
		ScreenSet.setWidowCenter(this);
		this.setTitle(Constant.REFILL+" 2/2");
		this.setVisible(true);
	}
	
	private void buttonEvenHandle(){
		resetBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setComponent();
			}
		});
		okBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				for(ButtonGroup b : questions){
					if(null == b.getSelection()){
						JOptionPane.showMessageDialog(rs, Constant.WARRING_MSG_ANSWER_SELECT, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
						return;
					}
				}
				refill.saveToDB(questions);
				dispose();
			}
		});
	}

	//reset answer
	private void setComponent() {
		for(ButtonGroup qGroup : questions){
			qGroup.clearSelection();
		}
	}
//======== Build all the component ========
	private void createViews(){
		js = new JScrollPane();
		questionPanel = new JPanel();
		btnPanel = new JPanel();		
		js.setViewportView(questionPanel);
		
		questionPanel.setLayout(new BoxLayout(questionPanel, BoxLayout.PAGE_AXIS));
		
		questions = new ArrayList<ButtonGroup>();
		for(Question question : q.getQuestions()){
			questions.add(addQuestion(question));
		}
		
		btnPanel.setLayout(new FlowLayout());
		btnPanel.add(resetBtn = new JButton(Constant.RESET));
		btnPanel.add(okBtn = new JButton(Constant.OK));
		
		this.setLayout(new BorderLayout());
		this.add(js, BorderLayout.CENTER);
		this.add(btnPanel, BorderLayout.SOUTH);
		
		setComponent();
	}

	private ButtonGroup addQuestion(Question question) {
		singleQuestionPanel = new JPanel();
		singleQuestionPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		
		singleQuestionPanel.add(rbYes = new JRadioButton(pos));
		rbYes.setActionCommand("true");
		singleQuestionPanel.add(rbNo = new JRadioButton(neg));
		rbNo.setActionCommand("false");
		
		lbQuestion = new JLabel("Item : "+question.getQuestion());
		singleQuestionPanel.add(lbQuestion);

		ButtonGroup btnGroup = new ButtonGroup();
		btnGroup.add(rbYes);
		btnGroup.add(rbNo);
		
		questionPanel.add(singleQuestionPanel);
		return btnGroup;
	}
}
