package main.guildmodel;

import java.awt.BorderLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import model.GuidesModel;
import tools.util.Constant;

@SuppressWarnings("serial")
public class GuildDatabasePanel extends JPanel {
	
	private JButton newBtn;
	private JButton editBtn;
	private JButton delBtn;
	private JPanel btnPanel;
	private JTable ifdTable;
	private JScrollPane scrollPane;
	private GuidesModel iftModel;
	private GuildDatabasePanel gd;
	
	public GuildDatabasePanel(){
		gd = this;
		buildTable();
		buildUI();
		buildActionHandle();
	}
	
	protected void buildTable(){
		iftModel = GuidesModel.getTableModel();
		ifdTable = new JTable(iftModel){
			public String getToolTipText(MouseEvent event) {
				String tip = "";
		        Point p = event.getPoint();
		        int rowIndex = rowAtPoint(p);
		        if(rowIndex>-1){
		        	String content = (String) getValueAt(rowIndex, 2);
		        	tip += "<html>";
			        tip += content.replaceAll("\n", "<br>");
		        	tip += "</html>";
		        }
		        return tip;			
			}
		};
		//移除ID欄位
		ifdTable.removeColumn(ifdTable.getColumn(Constant.ID));
		scrollPane = new JScrollPane(ifdTable);
	}
	
	protected void buildUI(){
		newBtn = new JButton(Constant.GUIDES_INSERT);
		editBtn = new JButton(Constant.GUIDES_EDIT);
		delBtn = new JButton(Constant.GUIDES_DELETE);
		
		btnPanel = new JPanel();
		btnPanel.add(newBtn);
		btnPanel.add(editBtn);
		btnPanel.add(delBtn);
		
		this.setLayout(new BorderLayout());
		this.add(btnPanel, BorderLayout.NORTH);
		this.add(scrollPane, BorderLayout.CENTER);
	}
	
	protected void buildActionHandle(){
		newBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				new NewGuildDialog(gd, -1);
			}
		});
		
		editBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int[] id = ifdTable.getSelectedRows();
				if(id.length == 0){
					JOptionPane.showMessageDialog(gd, Constant.ERROR_MSG_NOT_SELECT, Constant.ERROR_MSG_ERROR, JOptionPane.ERROR_MESSAGE);
				}else{
					System.out.println(id[0]);
					new NewGuildDialog(gd, iftModel.getId(id[0]));
				}
			}
		});
		
		delBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int[] tmp = ifdTable.getSelectedRows();
				if(tmp.length == 0){
					JOptionPane.showMessageDialog(gd, Constant.ERROR_MSG_NOT_SELECT, Constant.ERROR_MSG_ERROR, JOptionPane.ERROR_MESSAGE);
				}else{
					int choose = JOptionPane.showConfirmDialog(gd, Constant.MSG_IS_DELETE, Constant.MSG_IS_DELETE, JOptionPane.YES_NO_OPTION);
					if( choose == JOptionPane.YES_OPTION ){
						//取得 ID 是 Model 中的第幾欄
						int j = GuidesModel.getTableModel().findColumn(Constant.ID);
						for (int i = 0; i < tmp.length; ++i) {
							tmp[i] = Integer.parseInt(GuidesModel.getTableModel().getValueAt(tmp[i], j).toString());
						}
						for(int i = 0; i < tmp.length; i++){
							GuidesModel.delete(tmp[i]);
						}
					}
				}
			}
		});
		
	}
	
	public void refresh(){
		ifdTable.updateUI();
	}

}
 