package main.guildmodel;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

import model.GuidesModel;
import tools.util.Constant;
import tools.util.ScreenSet;

@SuppressWarnings("serial")
public class NewGuildDialog extends JDialog {
	
	private JTextField tfTitle = new JTextField(15);
	private JTextArea taContent = new JTextArea("", 5, 15);
	private JButton okBtn = new JButton(Constant.OK), cancelBtn = new JButton(Constant.CANCEL);
	private int id;
	private NewGuildDialog ng;

	public NewGuildDialog(GuildDatabasePanel gd, int id) {
//		ResourceBundle res = Tools.getResourceBundle("zw", "TW");
		super((Frame) gd.getTopLevelAncestor(), true);
		ng = this;
		this.id = id;

		JPanel contentPanel = new JPanel();
		contentPanel.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = 0;
		c.gridy = 0;
		contentPanel.add(new JLabel(Constant.GUIDES_TITLE+"："), c);
		c.gridx = 1;
		c.gridy = 0;
		contentPanel.add(tfTitle, c);
		c.gridx = 0;
		c.gridy = 1;
		contentPanel.add(new JLabel(Constant.GUIDES_GUIDE+"："), c);
		c.gridx = 1;
		c.gridy = 1;
		contentPanel.add(new JScrollPane(taContent), c);
		
		
		
		if (id >= 0) {
//			System.out.println(id);
			this.setTitle(Constant.GUIDES_EDIT);
			tfTitle.setText(GuidesModel.getTitle(id));
			taContent.setText(GuidesModel.getGuide(id));
		} else {
			this.setTitle(Constant.GUIDES_INSERT);
		}

		buildActionHandle();
		
		JPanel btnPanel = new JPanel();
		btnPanel.add(okBtn);
		btnPanel.add(cancelBtn);
		btnPanel.setLayout(new FlowLayout());

		BorderLayout layout = new BorderLayout();
		this.setLayout(layout);
		this.add(contentPanel, BorderLayout.CENTER);
		this.add(btnPanel, BorderLayout.SOUTH);
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setVisible(true);
	}

	protected void buildActionHandle() {

		Action doClickOk = new AbstractAction() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				okBtn.doClick();
			}
		};
		tfTitle.getInputMap().put(KeyStroke.getKeyStroke("ENTER"), "enter2submit");
		tfTitle.getActionMap().put("enter2submit", doClickOk);
		
		okBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				if (id >= 0) {
					// edit
					if (tfTitle.getText().equals("")||taContent.getText().equals("")) {
						JOptionPane.showMessageDialog(ng,Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING, JOptionPane.ERROR_MESSAGE);
					} else {
						boolean b = GuidesModel.update(id, tfTitle.getText(), taContent.getText());
						if(!b){
							JOptionPane.showMessageDialog(ng, 
									Constant.ERROR_MSG_CAN_NOT_UPDATE, Constant.ERROR_MSG_ERROR, 
									JOptionPane.ERROR_MESSAGE);
							return;
						}
						dispose();
					}
					
				}else{
					// new
					if (tfTitle.getText().equals("")||taContent.getText().equals("")) {
						JOptionPane.showMessageDialog(ng,Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING, JOptionPane.ERROR_MESSAGE);
					} else {
						int i = GuidesModel.insert(tfTitle.getText(), taContent.getText());
						if(-1 == i){
							JOptionPane.showMessageDialog(ng, 
									Constant.ERROR_MSG_CAN_NOT_INSERT, Constant.ERROR_MSG_ERROR, 
									JOptionPane.ERROR_MESSAGE);
							return;
						}
						dispose();
					}
				}

			}
		});

		cancelBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		});
	}
}
