package main.interferencemodel;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import tools.util.Constant;

import model.FakeQuestionsModel;

@SuppressWarnings("serial")
public class InterferenceDatabasePanel extends JPanel {
	
	private JButton newBtn;
	private JButton insertFromPhraseBtn;
	private JButton editBtn;
	private JButton delBtn;
	private JPanel btnPanel;
	private JTable ifdTable;
	private JScrollPane scrollPane;
	private FakeQuestionsModel iftModel;
	private InterferenceDatabasePanel ifdPanel;
	
	public InterferenceDatabasePanel(){
		ifdPanel = this;
		buildTable();
		buildUI();
		buildActionHandle();
	}
	
	protected void buildTable(){
//		String[] columnNames = {
//				Constant.ID,
//				Constant.INTERFERENCE_SENTENCES
//		};
//		iftModel = new InterferenceTableModel(columnNames);
//		iftModel.getAll();
		iftModel = FakeQuestionsModel.getTableModel();
		ifdTable = new JTable(iftModel);
		ifdTable.setPreferredScrollableViewportSize(new Dimension(500, 100));
		ifdTable.setFillsViewportHeight(true);
		scrollPane = new JScrollPane(ifdTable);
	}
	
	protected void buildUI(){
		newBtn = new JButton(Constant.FAKE_QUE_INSERT);
		insertFromPhraseBtn = new JButton(Constant.FAKE_QUE_INSERT_FROM_PHRASE);
		editBtn = new JButton(Constant.FAKE_QUE_EDIT);
		delBtn = new JButton(Constant.FAKE_QUE_DELETE);
		
		btnPanel = new JPanel();
		
		btnPanel.add(newBtn);
//		btnPanel.add(insertFromPhraseBtn);
		btnPanel.add(editBtn);
		btnPanel.add(delBtn);
		
		this.setLayout(new BorderLayout());
		this.add(btnPanel, BorderLayout.NORTH);
		this.add(scrollPane, BorderLayout.CENTER);
		
		refresh();
	}
	
	protected void buildActionHandle(){
		newBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				new NewInterferenceDialog(ifdPanel, null);
			}
		});
		
		editBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int[] id = ifdTable.getSelectedRows();
				if(id.length == 0){
					JOptionPane.showMessageDialog(ifdPanel, Constant.ERROR_MSG_NOT_SELECT, Constant.ERROR_MSG_ERROR, JOptionPane.ERROR_MESSAGE);
				}else{
					new NewInterferenceDialog(ifdPanel, String.valueOf(iftModel.getId(id[0])));
				}
			}
		});
		
		delBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int[] id = ifdTable.getSelectedRows();
				if(id.length == 0){
					JOptionPane.showMessageDialog(ifdPanel, Constant.ERROR_MSG_NOT_SELECT, Constant.ERROR_MSG_ERROR, JOptionPane.ERROR_MESSAGE);
				}else{
					int choose = JOptionPane.showConfirmDialog(ifdPanel, Constant.MSG_IS_DELETE, Constant.MSG_IS_DELETE, JOptionPane.YES_NO_OPTION);
					if( choose == JOptionPane.YES_OPTION ){
						for (int i = 0; i < id.length; ++i) {
							id[i] = iftModel.getId(id[i]);
						}
						for(int i = 0; i < id.length; i++){
							FakeQuestionsModel.delete(id[i]);
						}
					}
				}
				ifdPanel.refresh();
			}
		});
		
		insertFromPhraseBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				new NewInterferenceDialog(ifdPanel, "insertFromPhrase");
			}
		});
	}
	
	public void refresh(){
//		iftModel.getAll();
		ifdTable.updateUI();
	}

}
