package main.interferencemodel;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.KeyStroke;

import main.phrasemodel.vo.ExperData;
import main.phrasemodel.vo.PhraseData;
import model.FakeQuestionsModel;
import tools.db.DBConnector;
import tools.util.Constant;
import tools.util.ScreenSet;

public class NewInterferenceDialog extends JDialog {
	private static final long serialVersionUID = 4133704786558571845L;

	private JComboBox phraseComboBox;
	private JTextField tfContent;
	private JButton okBtn;
	private JButton cancelBtn;
	private String type;
	private ArrayList<PhraseData> data;
	private ArrayList<ExperData> expdata;
	private NewInterferenceDialog nif;

	public NewInterferenceDialog(InterferenceDatabasePanel ifdPanel, String type) {
//		ResourceBundle res = Tools.getResourceBundle("zw", "TW");
		super((Frame) ifdPanel.getTopLevelAncestor(), true);
		nif = this;
		this.type = type;
		
		JPanel contentPanel = new JPanel();
		if (type != null) {
			if (type.equals("insertFromPhrase")) {
				// insert from Phrase
				// TODO fix this after ...
				phraseComboBox = new JComboBox();
				data = new ArrayList<PhraseData>();
				// TODO refine this
				Statement st = DBConnector.getStatement();
				try {
					ResultSet rs = st.executeQuery("select * from "
							+ Constant.PHRASE_TABLE);
					while (rs.next()) {
						data.add(new PhraseData(rs));
					}
				} catch (SQLException e) {
					e.printStackTrace();
				}

				for (int i = 0; i < data.size(); i++) {
					phraseComboBox.addItem(data.get(i).getDescription());
				}
				contentPanel.setLayout(new BoxLayout(contentPanel,
						BoxLayout.PAGE_AXIS));
				Box box = Box.createVerticalBox();
				box.add(phraseComboBox);
				contentPanel.add(phraseComboBox);
				this.setTitle(Constant.FAKE_QUE_SELECT_PHRASE);
			} else {
				// edit
				FakeQuestionsModel tableModel = FakeQuestionsModel.getTableModel();
				int tmp = tableModel.getIndex(Integer.parseInt(type));
				tfContent = new JTextField(15);
				tfContent.setText(tableModel.getValueAt(tmp, 0).toString());
				contentPanel.add(new JLabel(Constant.FAKE_QUE_CONTENT));
				contentPanel.add(tfContent);
				this.setTitle(Constant.FAKE_QUE_EDIT);
			}
		} else {
			// new
			tfContent = new JTextField(15);
			contentPanel.add(new JLabel(Constant.FAKE_QUE_CONTENT));
			contentPanel.add(tfContent);
			this.setTitle(Constant.FAKE_QUE_INSERT);
		}

		JPanel btnPanel = new JPanel();
		okBtn = new JButton(Constant.OK);
		cancelBtn = new JButton(Constant.CANCEL);
		btnPanel.add(okBtn);
		btnPanel.add(cancelBtn);

		buildActionHandle();

		this.setLayout(new BorderLayout());
		this.add(btnPanel, BorderLayout.SOUTH);
		this.add(contentPanel, BorderLayout.CENTER);

		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setVisible(true);
	}

	@SuppressWarnings("serial")
	protected void buildActionHandle() {
		if (!"insertFromPhrase".equals(type)) { 
			Action doClickOk = new AbstractAction() {
				@Override
				public void actionPerformed(ActionEvent arg0) {
					okBtn.doClick();
				}
			};
			tfContent.getInputMap().put(KeyStroke.getKeyStroke("ENTER"), "enter2submit");
			tfContent.getActionMap().put("enter2submit", doClickOk);
		}

		okBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				FakeQuestionsModel tableModel = FakeQuestionsModel.getTableModel();
				if (type != null) {
					if (type.equals("insertFromPhrase")) {
						
						insertFromPhrase();
						tableModel.fireTableDataChanged();
					} else {
						// edit
						if (tfContent.getText().equals("")) {
							JOptionPane.showMessageDialog(nif,
									Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING,
									JOptionPane.WARNING_MESSAGE);
							return;
						} else {
							boolean b = FakeQuestionsModel.update(Integer.parseInt(type), tfContent.getText());
							if(!b){
								JOptionPane.showMessageDialog(nif, 
										Constant.ERROR_MSG_CAN_NOT_UPDATE, Constant.ERROR_MSG_ERROR, 
										JOptionPane.ERROR_MESSAGE);
								return;
							}
						}

					}
				} else {
					if (tfContent.getText().equals("")) {
						JOptionPane.showMessageDialog(nif,
								Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING,
								JOptionPane.WARNING_MESSAGE);
						return;
					} else {
						int i = FakeQuestionsModel.insert(tfContent.getText());
						if(-1 == i){
							JOptionPane.showMessageDialog(nif, 
									Constant.ERROR_MSG_CAN_NOT_INSERT, Constant.ERROR_MSG_ERROR, 
									JOptionPane.ERROR_MESSAGE);
							return;
						}
					}
				}
				dispose();
			}
		});

		cancelBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		});
	}
	
	public void insertFromPhrase(){
		// 取得物件id
		int idPhraseComboBox = 0;
		for (int i = 0; i < data.size(); i++) {
			if (data.get(i).getDescription().equals(phraseComboBox.getSelectedItem().toString())) {
				idPhraseComboBox = data.get(i).getId();
				break;
			}
		}
		
		// TODO get data from exp model!
		// 從句庫取得實驗句資料
		expdata = new ArrayList<ExperData>();
		Statement st = DBConnector.getStatement();
		try {
			ResultSet rs = st.executeQuery("select * from experimental where phrase_id ="+ idPhraseComboBox);
			while (rs.next()) {
				expdata.add(new ExperData(rs));
			}
		} catch (SQLException e2) {
			e2.printStackTrace();
		}

		// 檢查重覆並新增
		for (int i = 0; i < expdata.size(); i++) {
			FakeQuestionsModel.insert(expdata.get(i).getCase1());
			FakeQuestionsModel.insert(expdata.get(i).getCase2());
			FakeQuestionsModel.insert(expdata.get(i).getCase3());
			FakeQuestionsModel.insert(expdata.get(i).getCase4());
		}		
	}
	
}
