package main.phrasemodel.controller;

import javax.swing.JOptionPane;
import javax.swing.JTable;

import org.springframework.validation.BindException;

import main.phrasemodel.model.PhraseModel;
import main.phrasemodel.model.PhraseTableModel;
import main.phrasemodel.validation.PhraseValidator;
import main.phrasemodel.view.EditDialog;
import main.phrasemodel.vo.PhraseData;
import tools.util.Constant;

public class PhraseEditController {
	private EditDialog dialog;
	private PhraseModel model;
	
	public PhraseEditController(PhraseModel model, JTable table){
		this.model = model;
		dialog = new EditDialog(this, model);
		dialog.createView(getSelectedRowData(table));
	}
	
	protected PhraseData getSelectedRowData(JTable table){
		int row = table.getSelectedRow();
		PhraseTableModel pModel = (PhraseTableModel) table.getModel();
		String id = pModel.getValueAt(row, pModel.findColumn(Constant.ID)).toString();
		return model.select(id);
	}
	
	public void editPhraseData(){
		
		PhraseData pd = dialog.getUpdateData();
		PhraseValidator validator = new PhraseValidator();
		BindException errors = new BindException(pd, "PhraseData");
		validator.validate(pd, errors);
		if (errors.getErrorCount()>0) {
			JOptionPane.showMessageDialog(null, Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
			return;
		}
		model.doUpdate(pd);
		dialog.dispose();
	}
}
