package main.phrasemodel.controller;

import java.util.ArrayList;

import javax.swing.JTabbedPane;
import javax.swing.JTable;

import main.phrasemodel.management.controller.ManagementController;
import main.phrasemodel.management.model.EDModel;
import main.phrasemodel.management.model.ExperModel;
import main.phrasemodel.model.PhraseModel;
import main.phrasemodel.model.PhraseTableModel;
import main.phrasemodel.view.PhraseView;
import main.phrasemodel.vo.ED;
import main.phrasemodel.vo.PhraseData;
import tools.util.Constant;
import vo.ExportData;

public class PhraseMainController {
	private PhraseView phraseView;
	private PhraseModel model;
	
	public PhraseMainController(PhraseModel model, JTabbedPane tabbedPane){
		this.model = model;
		
		phraseView = new PhraseView(this, model);
		phraseView.createView();
		tabbedPane.addTab(Constant.FACTORS_MODEL, phraseView);
	}
	
	public void showNewDialg(){
		new PhraseNewController(model);
	}
	
	public void showEditDialg(JTable table) {
		new PhraseEditController(model, table);
	}
	
	public void showManagementDialg(JTable table) {
		int row = table.getSelectedRow();
		PhraseTableModel pModel = (PhraseTableModel) table.getModel();
		String id = pModel.getValueAt(row, pModel.findColumn(Constant.ID)).toString();
		new ManagementController(id, phraseView, model);
	}
	
	public void deletePhraseData(JTable table){
		model.doDelete(table);
	}

	public String export(JTable table) {
		StringBuffer sb = new StringBuffer("");
		
		PhraseTableModel pModel = (PhraseTableModel) table.getModel();
		String id = pModel.getValueAt(table.getSelectedRows()[0], pModel.findColumn(Constant.ID)).toString();
		
		PhraseData pd = model.select(id);
		EDModel eModel = new  ExperModel();
		ArrayList<ED> data = eModel.getPhraseAllExpers(id);
		
		sb.append("Factor 1 : " + pd.getFactor1().substring(0, 1) + System.getProperty("line.separator"));
		if(2 == pd.getFactorCount()){
			sb.append("Factor 2 : " + pd.getFactor2().substring(0, 1) + System.getProperty("line.separator"));
		}
		int mod = pd.getFactorCount() * 2;
		int item = 0;
		for(int i = 0; i < data.size(); i++){
			int set = i+ 1;
			ExportData eData = new ExportData(pd, data.get(i));
			eData.setSet(set);
			for(int j = 0; j < mod; j++){
				item++;
				addDataContext(eData, item, sb);
			}
		}
		return sb.toString();
	}
	
	protected void addDataContext(ExportData eData, int item, StringBuffer sb){
		eData.setItem(item);
		sb.append(eData.getString());
	}
}
