package main.phrasemodel.controller;

import javax.swing.JOptionPane;

import main.phrasemodel.model.PhraseModel;
import main.phrasemodel.validation.PhraseValidator;
import main.phrasemodel.view.NewDialog;
import main.phrasemodel.vo.PhraseData;

import org.springframework.validation.BindException;

import tools.util.Constant;

public class PhraseNewController {
	private NewDialog dialog;
	private PhraseModel model;
	
	public PhraseNewController(PhraseModel model){
		this.model = model;
		dialog = new NewDialog(this, model);
		dialog.createView();
	}
	
	public void addNewPhrase(){
			PhraseData pd = dialog.getInsertData();
			PhraseValidator validator = new PhraseValidator();
			BindException errors = new BindException(pd, "PhraseData");
			validator.validate(pd, errors);
			if (errors.getErrorCount()>0) {
				JOptionPane.showMessageDialog(null, Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
				return;
			}
			
			model.doInsert(pd);
			dialog.dispose();
	}
}
