package main.phrasemodel.management.controller;

import javax.swing.JTable;

import main.phrasemodel.controller.ManualAdd.ManualAddMainController;
import main.phrasemodel.management.model.EDModel;
import main.phrasemodel.management.view.ManagementView;
import main.phrasemodel.model.PhraseModel;
import main.phrasemodel.vi.ToolTipTextTable;
import main.phrasemodel.view.PhraseView;
import main.phrasemodel.vo.ED;
import main.phrasemodel.vo.PhraseData;

public class ManagementController {
	private PhraseView phraseView;
	private ManagementView view;

	public ManagementController(String id, PhraseView phraseView, PhraseModel pModel){
		this.phraseView = phraseView;
		view = new ManagementView(id, pModel, this);
		view.createView();
	}
	
	public void deletePhraseData(JTable table, EDModel model) {
		model.registerModelObserver(phraseView);
		model.doDelete(table);
	}

	public void showEditDialg(PhraseData pd, ToolTipTextTable table, EDModel model, String title) {
		new ManagementEditController(pd, model, table, title);
	}

	public void showNewDialg(PhraseData pd, EDModel model, String title) {
		model.registerModelObserver(phraseView);
		new ManagementNewController(pd, model, title);

	}
	
	public void showManualAddDialog(PhraseData pd){
		new ManualAddMainController(pd, phraseView, view.getExperPanel());
	}
	
	public void doInsert(ED data, EDModel model){
		model.doInsert(data);
	}
}
