package main.phrasemodel.management.controller;

import javax.swing.JOptionPane;
import javax.swing.JTable;

import main.phrasemodel.management.model.EDModel;
import main.phrasemodel.management.model.SuperTableModel;
import main.phrasemodel.management.view.ManagementEditDialog;
import main.phrasemodel.validation.EDValidator;
import main.phrasemodel.vo.ED;
import main.phrasemodel.vo.PhraseData;

import org.springframework.validation.BindException;

import tools.util.Constant;

public class ManagementEditController {
	
	private EDModel model;
	private ManagementEditDialog dialog;
	
	public ManagementEditController(PhraseData pd, EDModel model, JTable table, String title){
		this.model = model;
		
		dialog = new ManagementEditDialog(pd, this, model);
		dialog.createView(getSelectedRowData(table),title);
	}
	
	protected ED getSelectedRowData(JTable table){
		int row = table.getSelectedRow();
		SuperTableModel stModel = (SuperTableModel) table.getModel();
		String id = stModel.getValueAt(row, stModel.findColumn(Constant.ID)).toString();
		return model.select(id);
	}
	
	public void editDemoData(int factorCount){
		ED demoData = dialog.getUpdateData();
		EDValidator validator = new EDValidator(factorCount);
		BindException errors = new BindException(demoData, "DemoData");
		validator.validate(demoData, errors);
		if (errors.getErrorCount()>0) {
			JOptionPane.showMessageDialog(null, Constant.WARNING_MSG_MUST_HAVE_VALUE, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
			return;
		}
		if(demoData.isFieldDuplicate()){
			JOptionPane.showMessageDialog(null, Constant.ERROR_MSG_SENTENCE_CAN_NOT_REPEAT, Constant.WARNING_MSG_WARNING, JOptionPane.WARNING_MESSAGE);
			return;
		}
		if (model.isRowExist(demoData)) {
			JOptionPane.showMessageDialog(null, Constant.ERROR_MSG_CAN_NOT_UPDATE, Constant.ERROR_MSG_ERROR, JOptionPane.ERROR_MESSAGE);
			return;
		}
		if (model.isTitleDuplicate(demoData)) {
			JOptionPane.showMessageDialog(null, Constant.ERROR_MSG_TITLE_CAN_NOT_REPEAT, Constant.ERROR_MSG_ERROR, JOptionPane.ERROR_MESSAGE);
			return;
		}
		model.doUpdate(demoData);
		dialog.dispose();
	}
}
