package main.phrasemodel.management.model;

import java.util.ArrayList;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.support.rowset.SqlRowSet;

import tools.db.DAO;
import tools.util.Constant;

public class ExperModel extends EDModel {
	private static JdbcTemplate jdbcTemplate = DAO.getJdbcTemplate();
	
	public ExperModel() {
		super(Constant.EXPERIMENTAL_TABLE);
	}
	
	public static ArrayList<String> getExperSentenceByPhraseId(int id){
		ArrayList<String> sentences = new ArrayList<String>();
		String sql = "select * from " + Constant.EXPERIMENTAL_TABLE + " where phrase_id = ?;";
		SqlRowSet rs = jdbcTemplate.queryForRowSet(sql, id);
		while(rs.next()){
			sentences.add(rs.getString("case1"));
			sentences.add(rs.getString("case2"));
			if(getCaseNum(id) == 4){
				sentences.add(rs.getString("case3"));
				sentences.add(rs.getString("case4"));
			}
		}
		
		return sentences;
	}
	
	public int getNumOfExperByPhraseId(int id) {
		String sql = "select count(*) from " + Constant.EXPERIMENTAL_TABLE + " where phrase_id = ?;";
		return getCaseNum(id) * jdbcTemplate.queryForInt(sql, id);
	}
	
	public static int getCaseNum(int id) {
		int num = 4;
		String sql = "select case3 from " + Constant.EXPERIMENTAL_TABLE + " where phrase_id = ?;";
		SqlRowSet rs = jdbcTemplate.queryForRowSet(sql, id);
		if(rs.next()){
			if(rs.getString("case3") == null){
				num = 2;
			}
		}
		return num;
	}
}
