package main.phrasemodel.management.view;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import main.phrasemodel.management.controller.ManagementEditController;
import main.phrasemodel.management.model.EDModel;
import main.phrasemodel.vo.ED;
import main.phrasemodel.vo.PhraseData;
import tools.util.Constant;
import tools.util.ScreenSet;

public class ManagementEditDialog extends JDialog implements ActionListener {

	private static final long serialVersionUID = -1933818332855243309L;
	private ManagementEditController controller;
	private JTextField titleText;
	private JTextField case1Text;
	private JTextField case2Text;
	private JTextField case3Text;
	private JTextField case4Text;
	private JButton okBtn;
	private JButton cancelBtn;
	private PhraseData pd;
	private int id;
	
	public ManagementEditDialog(PhraseData pd, ManagementEditController controller, final EDModel model){
		this.controller = controller;
		this.pd = pd;
	}
	
	//XXX Extract
	public void createView(ED demo, String title){
		//XXX SelectPanel 也有相同的部分 可抽?
		JLabel titleLab = new JLabel(Constant.FACTOR_MANAGE_TITLE);
		JLabel case1Lab = new JLabel(Constant.D_CASE1);
		JLabel case2Lab = new JLabel(Constant.D_CASE2);
		JLabel case3Lab = new JLabel(Constant.D_CASE3);
		JLabel case4Lab = new JLabel(Constant.D_CASE4);
		
		titleText = new JTextField(15);
		case1Text = new JTextField(15);
		case2Text = new JTextField(15);
		case3Text = new JTextField(15);
		case4Text = new JTextField(15);
		
		titleText.setText(demo.getTitle());
		case1Text.setText(demo.getCase1());
		case2Text.setText(demo.getCase2());
		case3Text.setText(demo.getCase3());
		case4Text.setText(demo.getCase4());
		//XXX 似乎可以不用再告一個 id 變數。
		id = demo.getId();
		
		okBtn = new JButton(Constant.OK);
		cancelBtn = new JButton(Constant.CANCEL);
		
		okBtn.addActionListener(this);
		cancelBtn.addActionListener(this);
		
		JPanel titlePanel = new JPanel();
		titlePanel.add(titleLab);
		titlePanel.add(titleText);
		
		JPanel f1Panel = new JPanel();
		f1Panel.add(case1Lab);
		f1Panel.add(case1Text);
		
		JPanel f2Panel = new JPanel();
		f2Panel.add(case2Lab);
		f2Panel.add(case2Text);
		
		JPanel f3Panel = new JPanel();
		f3Panel.add(case3Lab);
		f3Panel.add(case3Text);
		
		JPanel f4Panel = new JPanel();
		f4Panel.add(case4Lab);
		f4Panel.add(case4Text);
		
		JPanel btnPanel = new JPanel();
		btnPanel.add(okBtn);
		btnPanel.add(cancelBtn);
		
		Box box = Box.createVerticalBox();
		box.add(titlePanel);
		box.add(f1Panel);
		box.add(f2Panel);
		
		if(pd.getFactorCount() == 2){
			box.add(f3Panel);
			box.add(f4Panel);
		}else{
			case1Lab.setText(Constant.B_CASE1);
			case2Lab.setText(Constant.B_CASE2);
		}
		box.add(btnPanel);
		
		this.add(box);
		this.getRootPane().setDefaultButton(okBtn);
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		if(title.equals(Constant.FACTOR_MANAGE_DEMO)){
			this.setTitle(Constant.FACTOR_MANAGE_DEMO_EDIT_TITLE);
		}else{
			this.setTitle(Constant.FACTOR_MANAGE_EXPER_EDIT_TITLE);
		}
		this.setSize(new Dimension(250, 200));
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setModal(true);
		this.setVisible(true);
	}
	
	public ED getUpdateData(){
		ED data = new ED();
		data.setTitle(titleText.getText());
		data.setCase1(case1Text.getText());
		data.setCase2(case2Text.getText());
		data.setCase3(case3Text.getText());
		data.setCase4(case4Text.getText());
		if(pd.getFactorCount() == 1){
			data.setCase3(null);
			data.setCase4(null);
		}
		data.setPhraseId(pd.getId());
		data.setId(id);
		return data;
	}
	
	public void actionPerformed(ActionEvent e) {
		Object btn = e.getSource();
		if(btn.equals(okBtn)){
			controller.editDemoData(pd.getFactorCount());
		}
		if(btn.equals(cancelBtn)){
			this.dispose();
		}
	}
}
