package main.phrasemodel.management.view;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JDialog;
import javax.swing.JFrame;

import main.phrasemodel.management.controller.ManagementController;
import main.phrasemodel.model.PhraseModel;
import main.phrasemodel.vo.PhraseData;
import tools.util.Constant;
import tools.util.ScreenSet;

public class ManagementView extends JDialog {
	private static final long serialVersionUID = -8649870306349558332L;
	private PhraseData pd;
	private ManagementController controller;
	private ExperPanel exper;
	
	public ManagementView(String id, final PhraseModel pModel, ManagementController controller){
		setController(controller);
		setPd(pModel.select(id));
	}
	
	public void createView(){
		
		DemoPanel demo = new DemoPanel(this, Constant.FACTOR_MANAGE_DEMO);
		exper = new ExperPanel(this, Constant.FACTOR_MANAGE_EXPER);
		demo.registerDemoObserver(exper);
		demo.checkExperBtnState(exper);
		
		this.setLayout(new BorderLayout());
		this.add(createInfoView(pd), BorderLayout.NORTH);
		this.add(demo, BorderLayout.CENTER);
		this.add(exper, BorderLayout.SOUTH);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setTitle(Constant.FACTOR_MANAGE);
		this.setSize(new Dimension(550, 400));
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setModal(true);
		this.setVisible(true);
	}
	
	protected PhraseInfoPanel createInfoView(PhraseData pd){
		return new PhraseInfoPanel(pd);
	}
	
	public PhraseData getPd() {
		return pd;
	}

	public void setPd(PhraseData pd) {
		this.pd = pd;
	}
	
	public ManagementController getController() {
		return controller;
	}

	public void setController(ManagementController controller) {
		this.controller = controller;
	}
	
	public ExperPanel getExperPanel(){
		return exper;
	}
}
