package main.phrasemodel.view;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

import main.phrasemodel.controller.PhraseEditController;
import main.phrasemodel.model.PhraseModel;
import main.phrasemodel.vo.PhraseData;
import tools.util.Constant;
import tools.util.ScreenSet;

public class EditDialog extends JDialog implements ActionListener {

	private static final long serialVersionUID = -1933818332855243309L;
	private PhraseEditController controller;
	private JTextField factorText1;
	private JTextField factorText2;
	private JTextField descriptionText;
	private JButton okBtn;
	private JButton cancelBtn;
	private int id;
	
	public EditDialog(PhraseEditController controller, final PhraseModel model){
		this.controller = controller;
	}
	
	public void createView(PhraseData pd){
		id = pd.getId();
		
		JLabel factor1Lab = new JLabel(Constant.FACTOR_FACTOR1+" : ");
		JLabel factor2Lab = new JLabel(Constant.FACTOR_FACTOR2+" : ");
		JLabel description = new JLabel(Constant.FACTOR_DESCRIPTION+" : ");
		
		factorText1 = new JTextField(15);
		descriptionText = new JTextField(15);
		
		factorText1.setText(pd.getFactor1());
		descriptionText.setText(pd.getDescription());
		
		okBtn = new JButton(Constant.OK);
		cancelBtn = new JButton(Constant.CANCEL);
		
		okBtn.addActionListener(this);
		cancelBtn.addActionListener(this);
		
		Box box = Box.createVerticalBox();
		Box b1 = Box.createHorizontalBox();
		b1.add(factor1Lab);
		b1.add(factorText1);
		box.add(b1);
		
		//XXX 可能可以抽!!
		if(pd.getFactorCount() == 2){
			factorText2 = new JTextField(15);
			factorText2.setText(pd.getFactor2());
			Box b2 = Box.createHorizontalBox();
			b2.add(factor2Lab);
			b2.add(factorText2);
			box.add(b2);
		}
		
		Box b3 = Box.createHorizontalBox();
		b3.add(description);
		b3.add(descriptionText);
		box.add(b3);
		
		Box b4 = Box.createHorizontalBox();
		b4.add(okBtn);
		b4.add(cancelBtn);
		box.add(b4);
		this.add(box);
		
		this.getRootPane().setDefaultButton(okBtn);
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		this.setTitle(Constant.FACTOR_EDIT_TITLE);
		this.setSize(new Dimension(250, 200));
		this.setResizable(false);
		this.pack();
		this.setModal(true);
		ScreenSet.setWidowCenter(this);
		this.setVisible(true);
	}
	
	public PhraseData getUpdateData(){
		PhraseData pd = new PhraseData();
		pd.setFactor1(factorText1.getText());
		pd.setDescription(descriptionText.getText());
		pd.setId(id);
		pd.setTotalSentences("0");
		//XXX 改得跟其他地方一樣
		if(factorText2 == null){
			pd.setFactor2(null);
		}else{
			pd.setFactor2(factorText2.getText());
		}
		return pd;
	}
	
	public void actionPerformed(ActionEvent e) {
		Object btn = e.getSource();
		if(btn.equals(okBtn)){
			controller.editPhraseData();
		}
		if(btn.equals(cancelBtn)){
			this.dispose();
		}
	}
}
