package main.phrasemodel.view.ManualAdd;

import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import tools.util.Constant;

import main.phrasemodel.controller.ManualAdd.ManualAddMainController;
import main.phrasemodel.vo.ExperData;

public class FinishModifyPanel extends JPanel {
	
	private static final long serialVersionUID = 3006645640220559645L;
	private ManualAddMainController controller;
	private JTextField[] caseText;
	private ArrayList<String> phrases;
	private JTextField title;
	FinishModifyState state;
	
	public FinishModifyPanel(FinishModifyState state){
		this.state = state;
		setBorder(BorderFactory.createTitledBorder(Constant.FACTOR_MANAGE_EXPER_MODIFY));
		
		controller = state.getController();
		Box box = Box.createVerticalBox();
		Box tb = Box.createHorizontalBox();
		Box b[] = new Box[4];
		
		caseText = new JTextField[4];
		JLabel[] caseLab = new JLabel[4];
		JLabel titleLab = new JLabel(Constant.FACTOR_MANAGE_TITLE);
		caseLab[0] = new JLabel(Constant.D_CASE1);
		caseLab[1] = new JLabel(Constant.D_CASE2);
		caseLab[2] = new JLabel(Constant.D_CASE3);
		caseLab[3] = new JLabel(Constant.D_CASE4);
		title = new JTextField(15);
		title.setText(controller.autoGenerateTitle() + "");
		tb.add(titleLab);
		tb.add(title);
		box.add(tb);
		phrases = controller.getReplacePhrases();
		for(int i = 0; i < phrases.size(); i++){
			b[i] = Box.createHorizontalBox();
			b[i].add(caseLab[i]);
			caseText[i] = new JTextField(15);
			caseText[i].setText(phrases.get(i));
			b[i].add(caseText[i]);
			box.add(b[i]);
		}
		
		if(state.getFactorCount() < 2){
			caseLab[0].setText(Constant.B_CASE1);
			caseLab[1].setText(Constant.B_CASE2);
		}
		
		JLabel msg = new JLabel(Constant.FACTOR_MANAGE_EXPER_NOTE);
		box.add(msg);
		this.add(box);
	}
	
	public ExperData getInsertData(){
		ExperData data = new ExperData();
		data.setId(0);
		data.setTitle(title.getText());
		data.setCase1(caseText[0].getText());
		data.setCase2(caseText[1].getText());
		if(caseText[2] != null){
			data.setCase3(caseText[2].getText());
			data.setCase4(caseText[3].getText());
		}else{
			data.setCase3(null);
			data.setCase4(null);
		}
		
		data.setPhraseId(state.getPhraseId());
		return data;
	}
}
