package main.phrasemodel.view.ManualAdd;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

import main.phrasemodel.controller.ManualAdd.ManualAddMainController;
import main.phrasemodel.model.ManualAdd.ManualAddModel;
import main.phrasemodel.vo.PhraseData;
import tools.util.Constant;
import tools.util.ScreenSet;

public class FinishModifyState extends JDialog implements ActionListener, State {
	
	private static final long serialVersionUID = 7752868422892343215L;
	private ManualAddMainController controller;
	private ManualAddModel model;
	private PhraseData pd;
	private JButton nextBtn;
	private JButton prevBtn;
	private JButton finishBtn;
	private JButton cancelBtn;
	private FinishModifyPanel fp;
	
	public FinishModifyState(ManualAddMainController controller, ManualAddModel model, PhraseData pd){
		this.controller = controller;
		this.model = model;
		this.pd = pd;
	}
	
	public void createView(){
		
		nextBtn = new JButton(Constant.CONTINUE_INSERT);
		prevBtn = new JButton(Constant.PREV);
		finishBtn = new JButton(Constant.FINISH);
		cancelBtn = new JButton(Constant.CANCEL);
		
		nextBtn.addActionListener(this);
		prevBtn.addActionListener(this);
		finishBtn.addActionListener(this);
		cancelBtn.addActionListener(this);
		
		fp = new FinishModifyPanel(this);
		JPanel btnPanel = new JPanel();
		btnPanel.add(prevBtn);
		btnPanel.add(nextBtn);
		btnPanel.add(finishBtn);
		
		this.setLayout(new BorderLayout());
		this.add(fp, BorderLayout.CENTER);
		this.add(btnPanel, BorderLayout.SOUTH);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setTitle(Constant.FACTOR_MANAGE + " - " + Constant.FACTOR_MANAGE_EXPER_FROMDEMO);
		this.setSize(new Dimension(550, 400));
		
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setModal(true);
		this.setVisible( true );
	}

	public ManualAddMainController getController() {
		return controller;
	}

	public ManualAddModel getModel() {
		return model;
	}

	public void setModel(ManualAddModel model) {
		this.model = model;
	}

	public int getFactorCount() {
		return pd.getFactorCount();
	}
	
	public int getPhraseId() {
		return pd.getId();
	}
	
	public void actionPerformed(ActionEvent e) {
		Object btn = e.getSource();
		if(btn.equals(finishBtn)){
			if(controller.insertExperDataByDemoData(fp.getInsertData())){
				this.dispose();
				controller.cancel();
			}
		}else if(btn.equals(prevBtn)){
			controller.prev();
			this.dispose();
			controller.createView();
		}else if(btn.equals(nextBtn)){
			if(controller.insertExperDataByDemoData(fp.getInsertData())){
				controller.next();
				this.dispose();
				controller.createView();
			}
		}
	}

	public void next() {
		controller.setReplaceState(new ReplacePhraseState(controller, model, pd));
		controller.setState(controller.getReplaceState());
	}

	public void prev() {
		controller.setReplaceState(new ReplacePhraseState(controller, model, pd));
		controller.setState(controller.getReplaceState());
	}

	public void cancel() {
	}
}
