package main.phrasemodel.view.ManualAdd;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.text.AbstractDocument;
import javax.swing.text.Document;
import javax.swing.text.DocumentFilter;

import main.phrasemodel.controller.ManualAdd.ManualAddMainController;
import main.phrasemodel.model.ModifyPhraseTableModel;
import tools.util.Constant;

public class ModifyPhrasePanel extends JPanel {

	private static final long serialVersionUID = 160538817476076291L;
	
	private ManualAddMainController controller;
	private JTextField[] caseText;
	private ArrayList<String> group;
	private ArrayList<String> result;
	private JTable table;
	
	public ModifyPhrasePanel(ModifyState state){
		controller = state.getController();
		
		setBorder(BorderFactory.createTitledBorder(Constant.FACTOR_MANAGE_EXPER_MANUAL_SPLIT));
		
		caseText = new JTextField[4];
		JLabel[] caseLab = new JLabel[4];
		caseLab[0] = new JLabel(Constant.D_CASE1);
		caseLab[1] = new JLabel(Constant.D_CASE2);
		caseLab[2] = new JLabel(Constant.D_CASE3);
		caseLab[3] = new JLabel(Constant.D_CASE4);
		
		Box box = Box.createVerticalBox();
		Box[] b = new Box[4];
		
		result = controller.getResult();
		for(int i = 0; i < result.size(); i++){
			b[i] = Box.createHorizontalBox();
			b[i].add(caseLab[i]);
			caseText[i] = new JTextField(15);
			caseText[i].setText(result.get(i));
			Document doc = caseText[i].getDocument();
			DocumentFilter filter = new InputStringDocumentFilter();
			((AbstractDocument)doc).setDocumentFilter(filter);
			caseText[i].setDocument(doc);
			b[i].add(caseText[i]);
			box.add(b[i]);
		}
		
		if(state.getFactorCount() < 2){
			caseLab[0].setText(Constant.B_CASE1);
			caseLab[1].setText(Constant.B_CASE2);
		}
		
		table = new JTable();
		setResultTable();
		JScrollPane jscp = new JScrollPane(table);
		
		this.setLayout(new BorderLayout());
		this.add(box, BorderLayout.NORTH);
		this.add(jscp, BorderLayout.SOUTH);
	}
	
	public void setResultTable(){
		group = controller.getGroup();
		Object[][] cellData = new Object[group.size()][1];
		for(int i = 0; i < group.size(); i++){
			cellData[i][0] = group.get(i);
		}
		String[] columnNames = {Constant.FACTOR_MANAGE_EXPER_RESULT};
		ModifyPhraseTableModel model = new ModifyPhraseTableModel(columnNames, cellData);
		table.setPreferredScrollableViewportSize(new Dimension(200, 100));
		table.setFillsViewportHeight(true);
		table.setModel(model);
	}
	
	public void setPhrases(ModifyState state){
		ArrayList<String> phrases = new ArrayList<String>();
		
		phrases.add(caseText[0].getText());
		phrases.add(caseText[1].getText());
		if(state.getFactorCount() > 1){
			phrases.add(caseText[2].getText());
			phrases.add(caseText[3].getText());
		}
		controller.setPhrases(phrases);
	}
}
