package main.phrasemodel.view.ManualAdd;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map.Entry;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

import main.phrasemodel.controller.ManualAdd.ManualAddMainController;
import main.phrasemodel.model.ManualAdd.ReplaceTableModel;
import tools.util.Constant;
import vo.CustomMap;

public class ReplacePhrasePanel extends JPanel implements TableModelListener {
	
	private static final long serialVersionUID = 3322991244386988826L;
	private ManualAddMainController controller;
	private JTextField[] caseText;
	private ArrayList<String> group;
	private ArrayList<CustomMap> splitGroup;
	private ArrayList<String> phrases;
	private ArrayList<String> cp;
	private JTable table;
	
	public ReplacePhrasePanel(ReplacePhraseState state){
		setBorder(BorderFactory.createTitledBorder(Constant.FACTOR_MANAGE_EXPER_REPLACE));
		
		controller = state.getController();
		
		splitGroup = controller.getSplitGroup();
		group = controller.getGroup();
		Object[][] object = new Object[group.size()][2];
		for(int i = 0; i < group.size(); i++){
			object[i][0] = group.get(i);
			object[i][1] = "";
		}
		
		String[] columnNames = {Constant.FACTOR_MANAGE_EXPER_RESULT, Constant.FACTOR_MANAGE_EXPER_REPLACE_WITH};
		ReplaceTableModel tableModel = new ReplaceTableModel(object, columnNames);
		tableModel.addTableModelListener(this);
		table = new JTable();
		table.setModel(tableModel);
		table.setPreferredScrollableViewportSize(new Dimension(200, 100));
		table.setFillsViewportHeight(true);
		JScrollPane jscp = new JScrollPane(table);
		
		caseText = new JTextField[4];
		JLabel[] caseLab = new JLabel[4];
		caseLab[0] = new JLabel(Constant.D_CASE1);
		caseLab[1] = new JLabel(Constant.D_CASE2);
		caseLab[2] = new JLabel(Constant.D_CASE3);
		caseLab[3] = new JLabel(Constant.D_CASE4);
		
		Box box = Box.createVerticalBox();
		Box[] b = new Box[4];
		
		cp = new ArrayList<String>();
		phrases = controller.getPhrases();
		for(int i = 0; i < phrases.size(); i++){
			cp.add(phrases.get(i));
			b[i] = Box.createHorizontalBox();
			b[i].add(caseLab[i]);
			caseText[i] = new JTextField(15);
			caseText[i].setText(phrases.get(i));
			caseText[i].setEditable(false);
			b[i].add(caseText[i]);
			box.add(b[i]);
		}
		
		if(state.getFactorCount() < 2){
			caseLab[0].setText(Constant.B_CASE1);
			caseLab[1].setText(Constant.B_CASE2);
		}
		controller.setReplacePhrases(phrases);

		this.setLayout(new BorderLayout());
		this.add(jscp, BorderLayout.NORTH);
		this.add(box, BorderLayout.CENTER);
	}
	
	public void tableChanged(TableModelEvent model) {
		cp.clear();
        for(int j = 0; j < phrases.size(); j++){
			cp.add(phrases.get(j));
		}
        
        for(int i = 0; i < table.getRowCount(); i++){
        	//取得 word group
        	String lcOrginStr = table.getValueAt(i, 0).toString().toLowerCase();
        	//有輸入取代用的字詞
    		for (int j = 0; j < phrases.size(); j++) {
    			Iterator<Entry<String, ArrayList<Integer>>> iterator = splitGroup.get(j).entrySet().iterator();
    			 while (iterator.hasNext()) {
    				 String str = iterator.next().getKey();
    				 if (str.toLowerCase().equals(lcOrginStr)) {
    					 splitGroup.get(j).setValue(str, table.getValueAt(i, 1).toString());
    				 }
    			}
    		}
        }
    	
    	for(int i = 0; i < cp.size(); i++){
    		String str = "";
    		//若是英文就要以空格分隔
    		if(0 == controller.getType() || phrases.get(i).matches("[A-Za-z]+(.)*")){
    			str = " ";
    		}
    		cp.set(i, splitGroup.get(i).getAllValue(str));
    		caseText[i].setText(splitGroup.get(i).getAllValue(str));
		}
    	controller.setReplacePhrases(cp);
	}
}
