package main.phrasemodel.view.ManualAdd;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

import main.phrasemodel.controller.ManualAdd.ManualAddMainController;
import main.phrasemodel.model.ManualAdd.ManualAddModel;
import main.phrasemodel.vo.PhraseData;
import tools.util.Constant;
import tools.util.ScreenSet;

public class ReplacePhraseState extends JDialog implements ActionListener, State {
	
	private static final long serialVersionUID = 7752868422892343215L;
	private ManualAddMainController controller;
	private ManualAddModel model;
	private PhraseData pd;
	private JButton nextBtn;
	private JButton prevBtn;
	private JButton finishBtn;
	private JButton cancelBtn;
	
	public ReplacePhraseState(ManualAddMainController controller, ManualAddModel model, PhraseData pd){
		this.controller = controller;
		this.model = model;
		this.pd = pd;
	}
	
	public void createView(){
		nextBtn = new JButton(Constant.NEXT);
		prevBtn = new JButton(Constant.PREV);
		finishBtn = new JButton(Constant.FINISH);
		cancelBtn = new JButton(Constant.CANCEL);
		
		nextBtn.addActionListener(this);
		prevBtn.addActionListener(this);
		finishBtn.addActionListener(this);
		cancelBtn.addActionListener(this);
		
		ReplacePhrasePanel rp = new ReplacePhrasePanel(this);
		JPanel btnPanel = new JPanel();
		btnPanel.add(prevBtn);
		btnPanel.add(nextBtn);
		btnPanel.add(cancelBtn);
		
		this.setLayout(new BorderLayout());
		this.add(rp, BorderLayout.CENTER);
		this.add(btnPanel, BorderLayout.SOUTH);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setTitle(Constant.FACTOR_MANAGE + " - " + Constant.FACTOR_MANAGE_EXPER_FROMDEMO);
		this.setSize(new Dimension(550, 400));
		this.pack();
		ScreenSet.setWidowCenter(this);
		this.setModal(true);
		this.setVisible(true);
	}

	public ManualAddMainController getController() {
		return controller;
	}

	public ManualAddModel getModel() {
		return model;
	}

	public void setModel(ManualAddModel model) {
		this.model = model;
	}

	public int getFactorCount() {
		return pd.getFactorCount();
	}
	
	public void actionPerformed(ActionEvent e) {
		Object btn = e.getSource();
		if(btn.equals(nextBtn)){
			controller.next();
			this.dispose();
			controller.createView();
		}else if(btn.equals(prevBtn)){
			controller.prev();
			this.dispose();
			controller.createView();
		}else if(btn.equals(cancelBtn)){
			controller.cancel();
			this.dispose();
		}
	}
	
	public void next() {
		controller.setFinishModifyState(new FinishModifyState(controller, model, pd));
		controller.setState(controller.getFinishModifyState());
	}

	public void prev() {
		controller.setModifyState(new ModifyState(controller, model, pd));
		controller.setState(controller.getModifyState());
	}

	public void cancel() {
		controller.setCancelState(new CancelState());
		controller.setState(controller.getCancelState());
	}
}
