package main.phrasemodel.view.ManualAdd;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import main.phrasemodel.controller.ManualAdd.ManualAddMainController;
import main.phrasemodel.model.ManualAdd.ManualAddModel;
import main.phrasemodel.vo.DemoData;
import tools.util.Constant;

public class SelectDemoPhrasePanel extends JPanel implements ItemListener {
	private static final long serialVersionUID = 3089313233054527824L;
	private JComboBox titleList;
	private JTextField[] caseText;
	private ManualAddModel model;
	private ManualAddMainController controller;
	private ArrayList<DemoData> list;
	private SelectState state;
	
	public SelectDemoPhrasePanel(SelectState state){
		setBorder(BorderFactory.createTitledBorder(Constant.FACTOR_MANAGE_EXPER_SELECT_DEMO));
		
		this.state = state;
		model = state.getModel();
		controller = state.getController();
		
		JLabel[] caseLab = new JLabel[4];
		JLabel titleLab = new JLabel(Constant.FACTOR_MANAGE_TITLE+"：");
		caseLab[0] = new JLabel(Constant.D_CASE1+"：");
		caseLab[1] = new JLabel(Constant.D_CASE2+"：");
		caseLab[2] = new JLabel(Constant.D_CASE3+"：");
		caseLab[3] = new JLabel(Constant.D_CASE4+"：");
		
		caseText = new JTextField[4];
		for(int i = 0; i < 4; i++){
			caseText[i] = new JTextField(15);
			caseText[i].setEditable(false);
		}
		
		titleList = new JComboBox();
		
		titleList.addItemListener(this);
		list = model.getDemoDataList();
		for(int i = 0; i < list.size(); i++){
			DemoData demo = list.get(i);
			titleList.addItem(demo.getTitle());
		}
		
		Box box = Box.createVerticalBox();
		Box tb = Box.createHorizontalBox();
		Box b[] = new Box[4];
		
		tb.add(titleLab);
		tb.add(titleList);
		box.add(tb);
		
		for(int i = 0; i < state.getFactorCount() * 2; i++){
			b[i] = Box.createHorizontalBox();
			b[i].add(caseLab[i]);
			b[i].add(caseText[i]);
			box.add(b[i]);
		}
		
		if(state.getFactorCount() == 2){
			caseLab[0].setText(Constant.B_CASE1+"：");
			caseLab[1].setText(Constant.B_CASE2+"：");
		}
		
		this.add(box);
	}
	
	public void itemStateChanged(ItemEvent e) {
		JComboBox combo = (JComboBox) e.getSource();
		int index = combo.getSelectedIndex();

		caseText[0].setText(list.get(index).getCase1());
		caseText[1].setText(list.get(index).getCase2());
		caseText[2].setText(list.get(index).getCase3());
		caseText[3].setText(list.get(index).getCase4());
		
		ArrayList<String> phrases = new ArrayList<String>();
		
		phrases.add(caseText[0].getText());
		phrases.add(caseText[1].getText());
		if(state.getFactorCount() > 1){
			phrases.add(caseText[2].getText());
			phrases.add(caseText[3].getText());
		}
		controller.setPhrases(phrases);
	}
}
