package main.phrasemodel.view;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

import main.phrasemodel.controller.PhraseNewController;
import main.phrasemodel.model.PhraseModel;
import main.phrasemodel.vo.PhraseData;
import tools.util.Constant;
import tools.util.ScreenSet;

public class NewDialog extends JDialog implements ActionListener{

	private static final long serialVersionUID = -1933818332855243309L;
	private PhraseNewController controller;
	private JTextField factorText1;
	private JTextField factorText2;
	private JTextField descriptionText;
	private JButton okBtn;
	private JButton cancelBtn;
	
	public NewDialog(PhraseNewController controller, final PhraseModel model){
		this.controller = controller;
	}
	
	public void createView(){
		JLabel factor1Lab = new JLabel(Constant.FACTOR_FACTOR1+" : ");
		JLabel factor2Lab = new JLabel(Constant.FACTOR_FACTOR2+" : ");
		JLabel optionLab = new JLabel(Constant.FACTOR_OPTIONAL);
		JLabel description = new JLabel(Constant.FACTOR_DESCRIPTION+" : ");
		
		factorText1 = new JTextField(15);
		factorText2 = new JTextField(15);
		descriptionText = new JTextField(15);
		
		okBtn = new JButton(Constant.OK);
		cancelBtn = new JButton(Constant.CANCEL);
		
		okBtn.addActionListener(this);
		cancelBtn.addActionListener(this);
		
		Box b1 = Box.createHorizontalBox();
		b1.add(factor1Lab);
		b1.add(factorText1);
		Box b2 = Box.createHorizontalBox();
		b2.add(optionLab);
		b2.add(factor2Lab);
		b2.add(factorText2);
		Box b3 = Box.createHorizontalBox();
		b3.add(description);
		b3.add(descriptionText);
		Box b4 = Box.createHorizontalBox();
		b4.add(okBtn);
		b4.add(cancelBtn);
		Box box = Box.createVerticalBox();
		box.add(b1);
		box.add(b2);
		box.add(b3);
		box.add(b4);
		this.add(box);
		this.getRootPane().setDefaultButton(okBtn);
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		this.setTitle(Constant.FACTOR_INSERT_TITLE);
		this.setSize( 250, 200 );
		this.setResizable(false);
		this.pack();
		this.setModal(true);
		ScreenSet.setWidowCenter(this);
		this.setVisible( true );
	}
	
	public PhraseData getInsertData(){
		PhraseData pd = new PhraseData();
		pd.setFactor1(factorText1.getText());
		pd.setFactor2(factorText2.getText());
		if("".equals(factorText2.getText())){
			pd.setFactor2(null);
		}
		pd.setDescription(descriptionText.getText());
		pd.setTotalSentences("0");
		return pd;
	}
	
	public void actionPerformed(ActionEvent e) {
		Object btn = e.getSource();
		if(btn.equals(okBtn)){
			controller.addNewPhrase();
		}
		if(btn.equals(cancelBtn)){
			this.dispose();
		}
	}
}
