package main.setting;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import tools.util.Constant;
/**
 * Server URL 設置的 Panel。
 * @author pkwbim&Aries
 *
 */
public class ServerSettingPanel extends SettingObserverPanel implements DocumentListener {
	private static final long serialVersionUID = 7448636720935971458L;
	private SettingController controller;
	private JTextField serverText;
	
	public ServerSettingPanel(SettingController controller) {
		this.controller = controller;
		createView();
	}
	
	public void createView(){
		setBorder(BorderFactory.createTitledBorder("Server Setting"));
		
		JLabel serverLab = new JLabel(Constant.SERVER_URL);
		serverText = new JTextField(15);
		serverText.getDocument().addDocumentListener(this);
		
		initParameter();
		
		Box box = Box.createVerticalBox();
		Box b1 = Box.createHorizontalBox();
		b1.add(serverLab);
		b1.add(serverText);
		
		box.add(b1);
		
		add(box);
	}
	
	/**
	 * 先檢查資料庫有無該 setting row，有就取出值並設定對應的 TextField，
	 * 否則新該筆資料。
	 */
	protected void initParameter(){
		serverText.setText(controller.initParameter(Constant.SERVER));
	}

	public void changedUpdate(DocumentEvent e) {
	}

	public void insertUpdate(DocumentEvent e) {
		notifyBtnEnable();
	}

	public void removeUpdate(DocumentEvent e) {
		notifyBtnEnable();
	}
	
	public String getServerURL(){
		return serverText.getText();
	}
}
