package main.setting;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import tools.util.Constant;

import main.setting.observer.SettingObserver;
import model.SettingModel;

public class SettingPanel extends JPanel implements ActionListener, SettingObserver {
	
	private static final long serialVersionUID = 1348138495116691111L;
	private SettingModel model;
	private JButton okBtn;
	private MailSettingPanel mailPanel;
	private ServerSettingPanel serverPanel;
	private RSettingPanel rPanel;
	private SettingController controller;
	
	public SettingPanel() {
		model = new SettingModel();
		controller = new SettingController(model);
		
		okBtn = new JButton(Constant.APPLY);
		
		Box box = Box.createVerticalBox();
		
		okBtn.setEnabled(false);
		okBtn.addActionListener(this);
		
		LanguagePanel langPanel = new LanguagePanel(controller);
		mailPanel = new MailSettingPanel(controller);
		serverPanel = new ServerSettingPanel(controller);
		rPanel = new RSettingPanel(controller);
		langPanel.registerObserver(this);
		mailPanel.registerObserver(this);
		serverPanel.registerObserver(this);
		rPanel.registerObserver(this);
		
		box.add(langPanel);
		box.add(mailPanel);
		box.add(serverPanel);
		box.add(rPanel);
		box.add(okBtn);
		this.add(box);
	}
	
	public void setBtnEnabled() {
		okBtn.setEnabled(true);
	}
	
	public void actionPerformed(ActionEvent e) {
		if(okBtn.equals(e.getSource())){
			controller.setLanguage();
			
			controller.setMailSeeting(mailPanel.setMailSettingData());
			
			controller.setServerURL(serverPanel.getServerURL());
			
			if(!rPanel.isSelectedR()){
				JOptionPane.showMessageDialog(this, Constant.WARRING_MSG_NOT_SELECT);
				return;
			}
			controller.setR(rPanel.getRSettingData());
			okBtn.setEnabled(false);
		}
	}
}