package model;

import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.table.AbstractTableModel;

import org.springframework.jdbc.support.rowset.SqlRowSet;

import tools.db.DAO;

@SuppressWarnings("serial")
public class FactorsModel extends AbstractTableModel {
	
	static String TABLE = "phrase";
	static String[] COL_NAMES = {"id", "factor1", "factor2", "description", "total_sentences"};
	private static FactorsModel singleton = new FactorsModel();
	
	public static FactorsModel getTableModel() {
		return singleton;
	}
	
	//XXX 只有 test 有用到。
	// @return auto-generated id
	public static int insert(String description, String factor1, String factor2) {
		int i = DAO.insert("insert into " + TABLE + " values (null, '" + factor1 + "', '" + factor2 + "', '" + description + "', 0);");
		if (1 != i) {
			return -1;
		} else {
			// this depends on how you sort the data
			singleton.fireTableRowsInserted(singleton.getRowCount(), singleton.getRowCount());
			return getId(factor1, factor2, description);
		}
	}
	
	//XXX 只有 test 有用到。
	private static int getId(String factor1, String factor2, String description) {
		try {
			ResultSet rs = DAO.select("select " + COL_NAMES[0] + " from " + TABLE + " where " + COL_NAMES[1] + "='" + factor1 + "' and " + COL_NAMES[2] + "='" + factor2 + "' and " + COL_NAMES[3] + "='" + description + "';");
			rs.next();
			int id = rs.getInt(1);
			return id;
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			DAO.close();
		}
		return -1;
	}

	//XXX 只有 test 有用到。
	public static boolean update(int id, String factor1, String factor2, String description) {
		int i = DAO.update("update " + TABLE + " set " + COL_NAMES[1] + "='" + factor1 + "', " + COL_NAMES[2] + "='" + factor2 + "', " + COL_NAMES[3] + "='" + description + "' where " + COL_NAMES[0] + "='" + id + "';");
		if (1 == i) {
			int j = singleton.getIndex(id);
			singleton.fireTableRowsUpdated(j, j);
			return true;
		}
		return false;
	}
	
	//XXX 只有 test 有用到。
	// TODO 一併更新相關 model/table
	public static boolean delete(int id) {
		int index = singleton.getIndex(id);
		int i = DAO.delete("delete from " + TABLE + " where " + COL_NAMES[0] + "='" + id + "';");
		// ExperimentalModel.deleteAllOfPhraseId(id);
		// DemonstrateModel.deleteAllOfPhraseId(id);
		if (1 == i) {
			singleton.fireTableRowsDeleted(index, index);
			return true;
		}
		return false;
	}

	//圖方便的 method，事實上，沒有證據顯示 description 是 unique 的！
	public static int getId(String description) {
		try {
			ResultSet rs = DAO.select(String.format("select %s from %s where %s='%s';",
					COL_NAMES[0], TABLE, COL_NAMES[3], description));
			rs.next();
			return rs.getInt(1);
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			DAO.close();
		}
		return -1;		
	}

	public static String getDescription(int id) {
		SqlRowSet rs = DAO.select(String.format("select %s from %s where %s=?;",
				COL_NAMES[3], TABLE, COL_NAMES[0]), id);
		if(rs.next()){
			return rs.getString(COL_NAMES[3]);
		}
		return "";
	}

	private FactorsModel() {
	}
	
	//XXX test 才有用到
	public int getIndex(int id) {
		try {
			ResultSet rs = DAO.select("select " + COL_NAMES[0] + " from " + TABLE + " order by "+ COL_NAMES[0] +" desc;");
	 		int ret = -1;
			while (rs.next()) {
				++ret;
				if (rs.getInt(1) == id) {
					return ret;
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			DAO.close();
		}
		return -1;
	}

	@Override
	public int getColumnCount() {
		return COL_NAMES.length;
	}

	@Override
	public String getColumnName(int column) {
		return COL_NAMES[column];
	}

	@Override
	public int getRowCount() {
		int count = 0;
		try {
			ResultSet rs = DAO.select("select " + COL_NAMES[0] + " from " + TABLE + ";");
			while (rs.next()) {
				++count;
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			DAO.close();
		}
		return count;
	}

	@Override
	public Object getValueAt(int arg0, int arg1) {
		try {
			ResultSet rs = DAO.select("select " + COL_NAMES[arg1] + " from " + TABLE + " order by "+ COL_NAMES[0] +" desc;");
			for (; arg0 >= 0; --arg0) {
				rs.next();
			}
			return rs.getString(1);
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			DAO.close();
		}
		return null;
	}

	public int getId(int index) {
		return Integer.parseInt(getValueAt(index, 0).toString());
	}

}
