package model;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;

import tools.db.DAO;
import tools.util.Constant;
import vo.SettingData;

public class SettingModel {
	private static JdbcTemplate jdbcTemplate = DAO.getJdbcTemplate();
	
	public SettingModel(){}
	
	public SettingData select(String name){
		String sql = "select * from " + Constant.SETTING_TABLE + " where name = ?;";
		SettingData data = jdbcTemplate.queryForObject(sql, new Object[]{name}, new RowMapper<SettingData>(){
			public SettingData mapRow(ResultSet rs, int i)
					throws SQLException {
				return new SettingData(rs);
			}
		});
		
		return data;
	}
	
	public int insert(String name, String value){
		String sql = "insert into " + Constant.SETTING_TABLE + " values(?, ?);";
		return jdbcTemplate.update(sql, name, value);
	}
	
	public int update(String name, String value){
		String sql = "update " + Constant.SETTING_TABLE + " set value = ? where name = ?;";
		return jdbcTemplate.update(sql, value, name);
	}
	
	public boolean isRowExist(String name){
		String sql = "select count(*) from " + Constant.SETTING_TABLE + " where name = ?;";
		int num = jdbcTemplate.queryForInt(sql, new Object[]{name});
		
		if(num>0){
			return true;
		}else{
			return false;
		}
	}
}
