package model;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.UUID;

import tools.db.DAO;
import junit.framework.TestCase;

public class TestFactorsModel extends TestCase {

	private static String TABLE = "phrase";
	private static String[] COL_NAMES = {"id", "factor1", "factor2", "description", "total_sentences"};
	private FactorsModel fm;
	private ResultSet rs;
	private String descrip,factor1,factor2,description;
	
	protected void setUp() throws Exception {
		super.setUp();
		fm = FactorsModel.getTableModel();
		descrip = "1";
		factor1 = UUID.randomUUID().toString().substring(0, 4);
		factor2 = UUID.randomUUID().toString().substring(0, 4);
		description = UUID.randomUUID().toString().substring(0, 4);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testGetIdString() {
		try {
			rs = DAO.select("select " + COL_NAMES[0] + " from " + TABLE + " where " + COL_NAMES[3] + "= '"+ descrip +"';");
			rs.next();
			int i =rs.getInt(1);
			DAO.close();
			assertEquals(i, FactorsModel.getId("1"));
		} catch (SQLException e) {
			e.printStackTrace();
		} 
	}
	
	public void testInsertDelete() {
//		int i = DAO.insert("insert into " + TABLE + " values (null, '" + factor1 + "', '" + factor2 + "', '" + insertDescription + "', 0);");
		int id1 = FactorsModel.insert(description, factor1, factor2);
		int id2 = FactorsModel.getId(description);
		assertEquals(id2, id1);
		boolean b = FactorsModel.delete(id1);
		assertEquals(true, b);
	}

	public void testUpdate() {
		String tmp1,tmp2,tmp3;
		try {
			rs = DAO.select("select * from "+ TABLE +" order by id desc;");
			int id = rs.getInt(1);
			tmp1 = rs.getString(2);
			tmp2 = rs.getString(3);
			tmp3 = rs.getString(4);
			DAO.close();
			assertEquals(true, FactorsModel.update(id, factor1, factor2, description));
			rs = DAO.select("select * from "+ TABLE +" where id = "+ id +";");
			assertEquals(factor1, rs.getString(2));
			assertEquals(factor2, rs.getString(3));
			assertEquals(description, rs.getString(4));
			DAO.close();
			assertEquals(true, FactorsModel.update(id, tmp1, tmp2, tmp3));	
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public void testGetRowCount() {
		try {
			rs = DAO.select("select count(*) from "+ TABLE +";");
			int i = rs.getInt(1);
			assertEquals(i,fm.getRowCount());
		} catch (SQLException e) {
			e.printStackTrace();
		} finally{
			DAO.close();
		}
	}

	public void testGetValueAt() {
		try {
			ArrayList<ArrayList<String>> ls = new ArrayList<ArrayList<String>>();
			rs = DAO.select("select * from "+ TABLE +";");
			while(rs.next()){
				ArrayList<String> e = new ArrayList<String>();
				e.add(rs.getString(1));
				e.add(rs.getString(2));
				e.add(rs.getString(3));
				e.add(rs.getString(4));
				e.add(rs.getString(5));
				ls.add(e);
			}
			DAO.close();
			
			for(int i=0;i<COL_NAMES.length;i++){
				for(int j=0;j<fm.getRowCount();j++){
					assertEquals(ls.get(j).get(i), fm.getValueAt(j, i));
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args){
		junit.swingui.TestRunner.run(FactorsModel.class);
	}
}
