package model;

import junit.framework.TestCase;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.support.rowset.SqlRowSet;

import tools.db.DBConnector;
import vo.UploadQuestionaireData;

public class TestLittleOne extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testGetUploadQuestionaireData() {
		int questionnaireId = 1382;
		int questionexperId = 0;
		String pos = "";
		String neg = "";
		String guide = "";
		// 取得一個questionnaire_id
		String sql = "select * from questionnaire order by id desc;";
		JdbcTemplate connect = DBConnector.getJdbcTemplate();
		SqlRowSet rs = connect.queryForRowSet(sql);
		if (rs.next()) {
			questionnaireId = rs.getInt("id");
			questionexperId = rs.getInt("questionexper_id");
		}
		sql = "select * from questionexper where id = ?";
		rs = connect.queryForRowSet(sql, questionexperId);
		if (rs.next()) {
			pos = rs.getString("positive");
			neg = rs.getString("negative");
			guide = rs.getString("guidesentence");
		}

		
		// getUploadQuestionaireData需要questionnaire_id & uuid(uuid可為null)
		LittleOne l = new LittleOne();
		UploadQuestionaireData data = l.getUploadQuestionaireData(
				questionnaireId);
		// 比對該questionnaire_id的實驗裡面的肯定、否定、指導句
		assertEquals(data.getExperSentences().length, 5);
		assertEquals(pos, data.getPositive());
		assertEquals(neg, data.getNegative());
		assertEquals(guide, data.getGuidesentence());

	}

}
