package tools.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.commons.dbcp.BasicDataSource;
import org.springframework.jdbc.core.JdbcTemplate;

import tools.util.Constant;

public class DBConnector {
	private static String dbDriver = Constant.DRIVER;
//	private static String dbDriver = Constant.DRIVER;
	private static String dbUrl = Constant.DB_URL;
	private static String dbUser = "";
	private static String dbPass = "";
	private static BasicDataSource datasource;
	
	public static JdbcTemplate getJdbcTemplate(){
		if(datasource == null){
			datasource = new BasicDataSource();
			datasource.setDriverClassName(Constant.DRIVER);
			datasource.setUrl(Constant.DB_URL);
			datasource.setUsername("");
			datasource.setPassword("");
		}
		return new JdbcTemplate(datasource);
	}
	
	public static Statement getStatement(){
		try {
			Class.forName(dbDriver);
			Connection conn = DriverManager.getConnection(dbUrl, dbUser, dbPass);
			return conn.createStatement();
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
	
	public static void close(Statement stmt) throws SQLException{
		Connection conn = stmt.getConnection();
		stmt.close();
		conn.close();
	}
	
	public static void handleException(Exception e, String sql){
		System.out.println(sql);
		e.printStackTrace();
	}

	public static boolean execute(String sql) {
		Statement stmt=null;
		try {
			stmt = DBConnector.getStatement();
			stmt.execute(sql);
			return true;
		}catch (Exception e) {
			DBConnector.handleException(e, sql);
			return false;
		}finally{
			try {
				DBConnector.close(stmt);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}
}
