package tools.i18n;

import java.util.Locale;
import java.util.ResourceBundle;

import vo.SettingData;

import model.SettingModel;

public class I18N {
	private static ResourceBundle messages = ResourceBundle.getBundle("lang.MiniJudge");
	private static String currentLanguage = "";
	
	/**
	 * 設定語言
	 */
	public static void setLanguage(){
		ResourceBundle.clearCache();
		Locale locale;
		SettingModel model = new SettingModel();
		//判斷資料庫中無此筆資料。無則使用 Locale 預設值。
		if(model.isRowExist("language")){
			SettingData data = model.select("language");
			if(!"".equals(data.getValue()) && data.getValue().contains("_")){
				String[] sp = data.getValue().split("_");
				locale = new Locale(sp[0], sp[1]);
				Locale.setDefault(locale);
			}else{
				locale = Locale.getDefault();
			}
		}else{
			locale = Locale.getDefault();
		}
		
		messages = ResourceBundle.getBundle("lang.MiniJudge", locale);
    }
		
	/**
	 * 取得i18n對應文字
	 * @param key 想取得的文字
	 * @return i18n中代表文字
	 */
	public static String getString(String key){
		return messages.getString(key);
	}
	
	public static String getCurrentLanguage(){
		return currentLanguage;
	}
}
