package tools.util;

import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import main.phrasemodel.vo.PhraseData;
/**
 * 自訂 ComboBox 的內容，以符合需求。
 * @author linsir168
 *
 */
public class ComboBoxRenderer extends JLabel implements ListCellRenderer {

	private static final long serialVersionUID = 7834440816456204975L;

	public ComboBoxRenderer() {
        setOpaque(true);
    }

	public Component getListCellRendererComponent(JList list, Object object,
			int arg2, boolean isSelected, boolean arg4) {
		if (isSelected) {
            setBackground(list.getSelectionBackground());
            setForeground(list.getSelectionForeground());
        } else {
            setBackground(list.getBackground());
            setForeground(list.getForeground());
        }

		PhraseData pd = (PhraseData) object;
		setText(pd.getDescription()+"");
		return this;
	}

}
