package tools.util;

import tools.i18n.I18N;

public class Constant {
	//DB
	public static final String DRIVER = "org.sqlite.JDBC";
	public static final String DB_NAME = "MiniJudge.db";
	public static final String DB_URL = "jdbc:sqlite:"+DB_NAME;
	
	//Table Name
	public static final String PHRASE_TABLE = "phrase";
	public static final String DEMONSTRATION_TABLE = "demonstrate";
	public static final String EXPERIMENTAL_TABLE = "experimental";
	public static final String SETTING_TABLE = "setting";
	
	//Setting Constant
	public static final String RFILE = "rFile";
	public static final String RRESULT = "rResult";
	public static final String RTYPE = "rType";
	public static final String HOME = "home";
	public static final String R = "r";
	public static final String SMTP = "smtp";
	public static final String PORT = "port";
	public static final String SSL = "ssl";
	public static final String MAIL_USERNAME = "mail username";
	public static final String MAIL= "mail";
	public static final String SERVER = "server";
	public static final String CONTENT = "content";
	public static final String LANGUAGE_SETTING_NAME = "language";
	public static final String PASSWORD = "Password";
	public static final String TO = "To";
	public static final String SUBJECT = "Subject";
	public static final String SEND = "Send";
	
	public static final String LINK_REPLACEMENT = "$link";
	
	public static final String MAIL_TEMPLATE_LAB = "Mail Content Template:";
	public static final String SMTP_LAB = "SMTP Server:";
	public static final String PORT_LAB = "Port(optional):";
	public static final String SSL_LAB = "SSL";
	public static final String MAIL_USERNAME_LAB = "User Name:";
	public static final String MAIL_PASSWORD = "Password:";
	public static final String MAIL_ADDRESS_LAB = "Email Address:";
	public static final String SERVER_URL = "Server URL:";
	public static final String LANG_PATH = "lang";
	
	//GWT Server Url
	public static final String GWT_URL = "mini.html";
	public static final String GWT_DOWNLOAD_SURVEY_RESULT = "result.html";
	
	//r.data
	public static final String R_DATA = "r.data";
	
	//R.bat
	public static final String R_BAT = "R.bat";
	
	//R Script
	public static final String RX0 = "Test for satiation";
	public static final String R0X = "Factor out neighbors";
	
	public static final String getPath() {
		String path = System.getProperty("user.dir");
		if(!path.endsWith(System.getProperty("file.separator"))){
			path += System.getProperty("file.separator") + "rscript" + System.getProperty("file.separator");
		}
		return path;
	}
	
	public static final String R_NORMAL = getPath() + "normal.r";
	public static final String R_SATIATION = getPath() + "satiation.r";
	//產生相對應的 R script 檔名的陣列，依照 Setting 介面上的 checkbox array 數量與被選取的狀態編成二進制 code。
	//checkbox array 數量表示會有幾位數，例如 checkbox array 數量為 2 則編碼就為 00、01 ... ； 數量為 3 則編碼就為 000、001 ...以此類推。
	//而編碼中的 1 代表相對應的 checkbox 的狀態為被選取，因此依照編碼可以得知 checkbox array 被選取狀態。例如 001 表示 checkbox[2] 被選取。
	//因為目前只有兩個 checkbox 所以編碼為 00、01、10、11，
	//00 對應 R_SCRIPT_ARRAY[0]，其值為 Constant.R_NORMAL
	//01 對應 R_SCRIPT_ARRAY[1]，其值為 
	//10 對應 R_SCRIPT_ARRAY[2]，其值為 Constant.R_SATIATION
	//11 對應 R_SCRIPT_ARRAY[3]，其值為 
	public static final String[] R_SCRIPT_ARRAY =  new String[]{Constant.R_NORMAL, "", Constant.R_SATIATION, ""};
	
	//R Result
	public static final String R_ANALYSIS = "r_analysis.txt";
	public static final String R_RESULT_IMAGE = "r_plot.jpg";
	
	//XXX --------CONSTANT WITH I18N--------CONSTANT WITH I18N--------CONSTANT WITH I18N--------
	//Share
	public static final String ID = "ID";
	public static final String NUMOF = "No.";
	
	//Share->Button
	public static final String OK = I18N.getString("OK");
	public static final String CANCEL = I18N.getString("Cancel");
	public static final String YES = I18N.getString("Yes");
	public static final String NO = I18N.getString("No");
	public static final String CONTINUE = I18N.getString("Continue");
	public static final String RESET = I18N.getString("Reset");
	public static final String NEXT = I18N.getString("Next");
	public static final String PREV = I18N.getString("Prev");
	public static final String FINISH = I18N.getString("Finish");
	public static final String CONTINUE_INSERT = I18N.getString("ContinueInsert");
	public static final String GENERATE_R_DOT_DATA = I18N.getString("GenerateRDotData");
	public static final String EXPORT = I18N.getString("Export");
	//Share->MSG
	public static final String MSG_NOTE = I18N.getString("Msg.Note");
	public static final String MSG_INPUT = I18N.getString("Msg.Input");
	public static final String MSG_INPUT_MAIL = I18N.getString("Msg.InputMail");
	public static final String MSG_IS_DELETE = I18N.getString("Msg.isDelete");
	public static final String MSG_RESTART = I18N.getString("Msg.Restart");	
	public static final String MSG_NOT_SET_R = I18N.getString("Msg.NotSetR");
	public static final String MSG_DL_FINISH = I18N.getString("Msg.DLFinish");
	public static final String MSG_SET_COMPLETED = I18N.getString("Msg.SetCompleted");
	public static final String MSG_SET_FAILED = I18N.getString("Msg.SetFailed");
	public static final String MSG_NOT_SET = I18N.getString("Msg.NotSet");
	public static final String MSG_IS_OVER_WRITE = I18N.getString("Msg.IsOverWrite");
	public static final String MSG_DB_NOT_EXIST = I18N.getString("Msg.DBNotExist");
	public static final String MSG_DATA_EXPORTED_SUCCESSFUL = I18N.getString("Msg.DataExportedSuccessful");
	//Share->WarningMsg
	public static final String WARNING_MSG_WARNING = I18N.getString("WarningMsg.Warning");
	public static final String WARNING_MSG_MUST_HAVE_VALUE = I18N.getString("WarningMsg.MustHaveAValue");
	public static final String WARNING_MSG_PLEASE_SELECT = I18N.getString("WarningMsg.PleaseSelect");
	public static final String WARNING_MSG_PLEASE_INSERT = I18N.getString("WarningMsg.PleaseInsert");
	public static final String WARNING_MSG_CANT_FIND_R = I18N.getString("WarningMsg.CantFindR");
	public static final String WARNING_MSG_URL_MAL_FORMED = I18N.getString("WarningMsg.URLMalformed");
	public static final String WARRING_MSG_NOT_SELECT = I18N.getString("WarningMsg.NotSelect");
	public static final String WARRING_MSG_MORE_THAN_TWO = I18N.getString("WarningMsg.MoreThanTwo");
	public static final String WARRING_MSG_CHECK_ID_PASS = I18N.getString("WarningMsg.CheckIDPass");
	public static final String WARRING_MSG_ANSWER_SELECT = I18N.getString("WarningMsg.AnswerSelect");
	public static final String WARRING_MSG_WANT_TO_DO = I18N.getString("WarningMsg.SelectWantToDo");
	//Share->ErrorMsg
	public static final String ERROR_MSG_ERROR = I18N.getString("ErrorMsg.Error");
	public static final String ERROR_MSG_NOT_SELECT = I18N.getString("ErrorMsg.NotSelect");
	public static final String ERROR_MSG_ONLY_ONE = I18N.getString("ErrorMsg.OnlyOne");
	public static final String ERROR_MSG_CAN_NOT_INSERT = I18N.getString("ErrorMsg.CanNotInsert");
	public static final String ERROR_MSG_CAN_NOT_UPDATE = I18N.getString("ErrorMsg.CanNotUpdate");
	public static final String ERROR_RESTART = I18N.getString("ErrorMsg.Restart");
	public static final String ERROR_MSG_MUST_BE_A_NUM = I18N.getString("ErrorMsg.MustBeANum");
	public static final String ERROR_MSG_TITLE_CAN_NOT_REPEAT = I18N.getString("ErrorMsg.TitleNotRepeat");
	public static final String ERROR_MSG_SENTENCE_CAN_NOT_REPEAT = I18N.getString("ErrorMsg.SentenceNotRepeat");
	public static final String ERROR_MSG_NO_DATA_CAN_EXPORT = I18N.getString("ErrorMsg.NoDataCanExport");
	
	//Setting
	public static final String SETTING_RDIRECTORY = I18N.getString("Setting.RDirectory");
	public static final String SETTING_SET = I18N.getString("Setting.Set");
	public static final String SETTING_SETR = I18N.getString("Setting.SetR");
	public static final String SETTING_SAVE_RESULT = I18N.getString("Setting.SaveResult");
	public static final String SETTING_R_DEFAULT = I18N.getString("Setting.RDefault");
	public static final String SETTING_R_CUSTOM = I18N.getString("Setting.RCustom");
	
	//Models
	public static final String MAINFRAME = "MiniJudge";
	public static final String FACTORS_MODEL = I18N.getString("FactorsModel");
	public static final String FAKEQUESTION_MODEL = I18N.getString("FakeQuestionModel");
	public static final String GUIDES_MODEL = I18N.getString("GuidesModel");
	public static final String EXPERIMENT_MODEL = I18N.getString("ExperimentModel");
	
	public static final String SETTING = I18N.getString("Setting");
	public static final String LANGUAGE = I18N.getString("Language");
	public static final String APPLY = I18N.getString("Apply");
	public static final String REFILL = I18N.getString("Refill");
	
	//FactorModel  ------------------------------------------------------------------------
	//FactorModel->Button
	public static final String FACTOR_INSERT = I18N.getString("FactorsModel.Insert");
	public static final String FACTOR_EDIT = I18N.getString("FactorsModel.Edit");
	public static final String FACTOR_DELETE = I18N.getString("FactorsModel.Delete");
	//FactorModel->其他
	public static final String FACTOR_INSERT_TITLE = I18N.getString("FactorsModel.InsertTitle");
	public static final String FACTOR_EDIT_TITLE = I18N.getString("FactorsModel.EditTitle");
	public static final String FACTOR_FACTOR1 = I18N.getString("FactorsModel.Factor1");
	public static final String FACTOR_FACTOR2 = I18N.getString("FactorsModel.Factor2");
	public static final String FACTOR_DESCRIPTION = I18N.getString("FactorsModel.Description");
	public static final String FACTOR_OPTIONAL = "<" + I18N.getString("FactorsModel.Optional") + ">";
	public static final String FACTOR_TOTAL_SENTENCES = I18N.getString("FactorsModel.TotalSentences");
	//FactorModel->Management
	public static final String FACTOR_MANAGE = I18N.getString("FactorsModel.Manage");
	public static final String FACTOR_MANAGE_INFO = I18N.getString("FactorsModel.Manage.Info");
	public static final String FACTOR_MANAGE_DEMO = I18N.getString("FactorsModel.Manage.Demo");
	public static final String FACTOR_MANAGE_EXPER = I18N.getString("FactorsModel.Manage.Exper");
	public static final String FACTOR_MANAGE_TITLE = I18N.getString("FactorsModel.Manage.Title");
	//FactorModel->Management->Button
	public static final String FACTOR_MANAGE_DELETE = I18N.getString("FactorsModel.Manage.Delete");
	public static final String FACTOR_MANAGE_DEMO_INSERT = I18N.getString("FactorsModel.Manage.Demo.Insert");
	public static final String FACTOR_MANAGE_DEMO_INSERT_TITLE = I18N.getString("FactorsModel.Manage.Demo.InsertTitle");
	public static final String FACTOR_MANAGE_DEMO_EDIT = I18N.getString("FactorsModel.Manage.Demo.Edit");
	public static final String FACTOR_MANAGE_DEMO_EDIT_TITLE = I18N.getString("FactorsModel.Manage.Demo.EditTitle");
	public static final String FACTOR_MANAGE_EXPER_MANUAL = I18N.getString("FactorsModel.Manage.Exper.Manual");
	public static final String FACTOR_MANAGE_EXPER_FROMDEMO = I18N.getString("FactorsModel.Manage.Exper.FromDemo");
	public static final String FACTOR_MANAGE_EXPER_INSERT_TITLE = I18N.getString("FactorsModel.Manage.Exper.InsertTitle");
	public static final String FACTOR_MANAGE_EXPER_EDIT_TITLE = I18N.getString("FactorsModel.Manage.Exper.EditTitle");
	public static final String FACTOR_MANAGE_EXPER_MANUAL_INSERT_TITLE = I18N.getString("FactorsModel.Manage.Exper.ManualInsertTitle");
	public static final String FACTOR_MANAGE_EXPER_MANUAL_EDIT_TITLE = I18N.getString("FactorsModel.Manage.Exper.ManualEditTitle");
	public static final String FACTOR_MANAGE_EXPER_SELECT_DEMO = I18N.getString("FactorsModel.Manage.Exper.SelectDemo");
	public static final String FACTOR_MANAGE_EXPER_SELECT_SPLIT = I18N.getString("FactorsModel.Manage.Exper.SelectSplit");
	public static final String FACTOR_MANAGE_EXPER_EN = I18N.getString("FactorsModel.Manage.Exper.EN");
	public static final String FACTOR_MANAGE_EXPER_CH = I18N.getString("FactorsModel.Manage.Exper.CH");
	public static final String FACTOR_MANAGE_EXPER_NOT_USE = I18N.getString("FactorsModel.Manage.Exper.NotUse");
	public static final String FACTOR_MANAGE_EXPER_MANUAL_SPLIT = I18N.getString("FactorsModel.Manage.Exper.ManualSplit");
	public static final String FACTOR_MANAGE_EXPER_RESULT = I18N.getString("FactorsModel.Manage.Exper.Result");
	public static final String FACTOR_MANAGE_EXPER_SEE_SPLIT = I18N.getString("FactorsModel.Manage.Exper.SeeSplit");
	public static final String FACTOR_MANAGE_EXPER_REPLACE = I18N.getString("FactorsModel.Manage.Exper.Replace");
	public static final String FACTOR_MANAGE_EXPER_REPLACE_WITH = I18N.getString("FactorsModel.Manage.Exper.ReplaceWith");
	public static final String FACTOR_MANAGE_EXPER_MODIFY = I18N.getString("FactorsModel.Manage.Exper.Modify");
	public static final String FACTOR_MANAGE_EXPER_NOTE = I18N.getString("FactorsModel.Manage.Exper.Note");
	//FactorModel->Management->其他
	public static final String D_CASE1 = "+"+ FACTOR_FACTOR1 +", +"+FACTOR_FACTOR2;
	public static final String D_CASE2 = "+"+ FACTOR_FACTOR1 +", -"+FACTOR_FACTOR2;
	public static final String D_CASE3 = "-"+ FACTOR_FACTOR1 +", +"+FACTOR_FACTOR2;
	public static final String D_CASE4 = "-"+ FACTOR_FACTOR1 +", -"+FACTOR_FACTOR2;
	public static final String B_CASE1 = "+"+ FACTOR_FACTOR1;
	public static final String B_CASE2 = "-"+ FACTOR_FACTOR1;
	
	//FakeQuestionModel  ------------------------------------------------------------------
	//FakeQuestionModel->Button
	public static final String FAKE_QUE_INSERT = I18N.getString("FakeQuestionModel.Insert");
	public static final String FAKE_QUE_INSERT_FROM_PHRASE = I18N.getString("FakeQuestionModel.InsertFromPhrase");
	public static final String FAKE_QUE_EDIT = I18N.getString("FakeQuestionModel.Edit");
	public static final String FAKE_QUE_DELETE = I18N.getString("FakeQuestionModel.Delete");
	//FakeQuestionModel->其他
	public static final String FAKE_QUE_FAKE_QUE = I18N.getString("FakeQuestionModel.FakeQuestion");
	public static final String FAKE_QUE_CONTENT = I18N.getString("FakeQuestionModel.Content");
	public static final String FAKE_QUE_SELECT_PHRASE = I18N.getString("FakeQuestionModel.SelectPhrase");
	
	//GuidesModel  ------------------------------------------------------------------------
	//GuidesModel->Button
	public static final String GUIDES_INSERT = I18N.getString("GuidesModel.Insert");
	public static final String GUIDES_EDIT = I18N.getString("GuidesModel.Edit");
	public static final String GUIDES_DELETE = I18N.getString("GuidesModel.Delete");
	//GuidesModel->其他
	public static final String GUIDES_TITLE = I18N.getString("GuidesModel.Title");
	public static final String GUIDES_GUIDE = I18N.getString("GuidesModel.Guide");
	
	//ExperimentModel  --------------------------------------------------------------------
	//ExperimentModel->Experiment
	public static final String EXP_EXP = I18N.getString("ExperimentModel.Experiment");
	public static final String EXP_GUIDE = I18N.getString("ExperimentModel.Guide");
	public static final String EXP_QUE = I18N.getString("ExperimentModel.Question");
	//ExperimentModel->Experiment->MSG
	public static final String EXP_EXP_MSG_TOTAL = I18N.getString("ExperimentModel.Experiment.Msg.Total");
	public static final String EXP_EXP_MSG_NUM_EXP = I18N.getString("ExperimentModel.Experiment.Msg.NumOfExp");
	//ExperimentModel->Experiment->Button
	public static final String EXP_EXP_INSERT = I18N.getString("ExperimentModel.Experiment.Insert");
	public static final String EXP_EXP_EDIT = I18N.getString("ExperimentModel.Experiment.Edit");
	public static final String EXP_EXP_DELETE = I18N.getString("ExperimentModel.Experiment.Delete");
	public static final String EXP_EXP_SEE = I18N.getString("ExperimentModel.Experiment.See");
	public static final String EXP_EXP_ANALYSIS = I18N.getString("ExperimentModel.Experiment.Analysis");
	//ExperimentModel->Experiment->其他
	public static final String EXP_EXP_TITLE = I18N.getString("ExperimentModel.Experiment.Title");
	public static final String EXP_EXP_POSITIVE = I18N.getString("ExperimentModel.Experiment.Positive");
	public static final String EXP_EXP_NEGATIVE = I18N.getString("ExperimentModel.Experiment.Negative");
	public static final String EXP_EXP_FACTOR = I18N.getString("ExperimentModel.Experiment.Factor");
	public static final String EXP_EXP_DATE = I18N.getString("ExperimentModel.Experiment.Date");
	public static final String EXP_EXP_GUIDE_TITLE = I18N.getString("ExperimentModel.Experiment.GuideTitle");
	public static final String EXP_EXP_FAKE_QUE_NUM = I18N.getString("ExperimentModel.Experiment.InterferenceSentencesNum");
	public static final String EXP_EXP_EXPER_QUE_NUM = I18N.getString("ExperimentModel.Experiment.ExperienceSentencesNum");
	public static final String EXP_EXP_QUE_NUM = I18N.getString("ExperimentModel.Experiment.QuetionNumber");
		
	//ExperimentModel->Survey
	public static final String EXP_SURVEY = I18N.getString("ExperimentModel.Survey");
	//ExperimentModel->Survey->MSG
	public static final String EXP_SURVEY_MSG_STATE_IS = I18N.getString("ExperimentModel.Survey.Msg.StateIs");
	public static final String EXP_SURVEY_MSG_CAN_NOT_EXECUTE = I18N.getString("ExperimentModel.Survey.Msg.CanNotExecute");
	public static final String EXP_SURVEY_MSG_CONNECT_ERROR = I18N.getString("ExperimentModel.Survey.Msg.ConnectError");
	public static final String EXP_SURVEY_MSG_DATA_FORMATE_ERROR = I18N.getString("ExperimentModel.Survey.Msg.FormateError");
	public static final String EXP_SURVEY_MSG_MAIL_SENT = I18N.getString("ExperimentModel.Survey.Msg.MailSent");
	public static final String EXP_SURVEY_MSG_MAIL_SEND_FAILED = I18N.getString("ExperimentModel.Survey.Msg.MailSendFailed");
	//ExperimentModel->Survey->Button
	public static final String EXP_SURVEY_INSERT = I18N.getString("ExperimentModel.Survey.Insert");
	public static final String EXP_SURVEY_EDIT = I18N.getString("ExperimentModel.Survey.Edit");
	public static final String EXP_SURVEY_DELETE = I18N.getString("ExperimentModel.Survey.Delete");
	public static final String EXP_SURVEY_EXECUTE = I18N.getString("ExperimentModel.Survey.Execute");
	public static final String EXP_SURVEY_MAIL = I18N.getString("ExperimentModel.Survey.Mail");
	public static final String EXP_SURVEY_DOWNLOAD = I18N.getString("ExperimentModel.Survey.Download");
	public static final String EXP_SURVEY_PRINT = I18N.getString("ExperimentModel.Survey.Print");
	public static final String EXP_SURVEY_REFILL = I18N.getString("ExperimentModel.Survey.Refill");
	//ExperimentModel->Survey->其他
	public static final String EXP_SURVEY_NOTES = I18N.getString("ExperimentModel.Survey.Notes");
	public static final String EXP_SURVEY_STATE = I18N.getString("ExperimentModel.Survey.State");
	public static final String EXP_SURVEY_BUILDDATE = I18N.getString("ExperimentModel.Survey.BuildDate");
	public static final String EXP_SURVEY_EXPERDATE = I18N.getString("ExperimentModel.Survey.ExperimentDate");
	public static final String EXP_SURVEY_SUBJECT = I18N.getString("ExperimentModel.Survey.Subject");
	
	//ExperimentModel->ExecuteSurvey
	public static final String EXP_EXECUTE_SURVEY_SUBJECT_INFO = I18N.getString("ExperimentModel.ExecuteSurvey.SubjectInfo");
	public static final String EXP_EXECUTE_SURVEY_SUBJECT_NAME = I18N.getString("ExperimentModel.ExecuteSurvey.SubjectName");
	public static final String EXP_EXECUTE_SURVEY_SAVE_SURVEY = I18N.getString("ExperimentModel.ExecuteSurvey.SaveSurvey");
	public static final String EXP_EXECUTE_SURVEY_MSG_NOT_SELECT = I18N.getString("ExperimentModel.ExecuteSurvey.Msg.NotSelect");
	public static final String EXP_EXECUTE_SURVEY_MSG_NOT_FILL = I18N.getString("ExperimentModel.ExecuteSurvey.Msg.NotFill");
	public static final String EXP_EXECUTE_SURVEY_MSG_END = I18N.getString("ExperimentModel.ExecuteSurvey.Msg.End");
	
	//ExperimentModel->SurveySample
	public static final String EXP_SURSAMPLE = I18N.getString("ExperimentModel.SurveySample");
	public static final String EXP_SURSAMPLE_IS_FAKE = I18N.getString("ExperimentModel.SurveySample.isFakeQuestion");
}
