package tools.util;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.List;

import vo.UploadQuestionaireData;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

public class GsonGenerator {
	private Gson gson;
	private ArrayList<String> json;
	
	public GsonGenerator(){
		gson = new Gson();
		json = new ArrayList<String>();
	}
	
	/**
	 * 將問卷的肯定、否定、指導語與問卷內容轉成Json
	 * @param data
	 */
	public void generateDBJson(UploadQuestionaireData data) {
		Type type = new TypeToken<UploadQuestionaireData>(){}.getType();
		json.add("surveyData=" + gson.toJson(data, type));
	}
	
	/**
	 * 將要下載的問卷的 uuid 轉成 Json。
	 * @param canDl
	 */
	public void generateUUIDJson(List<String> canDl) {
		Type type = new TypeToken<List<String>>(){}.getType();
		json.add("uuid=" + gson.toJson(canDl, type));
	}
	
	public ArrayList<String> getJson(){
		return json;
	}
}
