package tools.util;

import java.awt.Component;
import java.util.Locale;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

public class I18NComboBoxRenderer extends JLabel implements ListCellRenderer {

	private static final long serialVersionUID = 6473305354964502825L;

	public I18NComboBoxRenderer() {
        setOpaque(true);
    }
	
	@Override
	public Component getListCellRendererComponent(JList list, Object object,
			int arg2, boolean isSelected, boolean arg4) {
		if (isSelected) {
            setBackground(list.getSelectionBackground());
            setForeground(list.getSelectionForeground());
        } else {
            setBackground(list.getBackground());
            setForeground(list.getForeground());
        }

		Locale locale = (Locale) object;
		setText(locale.getDisplayName());
		return this;
	}

}
