package tools.util;

import java.io.File;

import javax.swing.filechooser.FileFilter;

public class MiniFileFilter extends FileFilter {

	private String[] extensions;
	private String description;
	
	public MiniFileFilter(String[] extensions, String description){
		this.extensions = extensions;
		this.description = description;
	}
	
	public boolean accept(File file) {
		for (String extension : extensions){
			if (file.getName().toLowerCase().endsWith("." + extension)){
				return true;
			}
		}
		return false;
	}

	public String getDescription() {
		return description;
	}
}
