package tools.validation;

import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import vo.MailInfo;

public class MailValidation implements Validator {
	
	public boolean supports(Class<?> arg0) {
		return MailInfo.class.isAssignableFrom(arg0);
	}

	public void validate(Object object, Errors errors) {
		MailInfo info = (MailInfo) object;
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "smtp", "not set smtp", "smtp:not set smtp");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "not set name", "name:not set name");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "password", "required", "password:required");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "sender", "not set mail", "sender:not set mail");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "reciver", "required", "reciver:required");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "subject", "required", "subject:required");
		ValidationUtils.rejectIfEmptyOrWhitespace(errors, "context", "required", "context:required");
		
		if(checkEmail(info.getReciver())){
			errors.rejectValue("reciver", "reciver email format error", "reciver email: format error");
		}
	}
	
	protected boolean checkEmail(String mail){
		return !mail.matches("^[_a-z0-9-]+([.][_a-z0-9-]+)*@[a-z0-9-]+([.][a-z0-9-]+)*$");
	}
}
